/**********************************************************************
 * Copyright (c) 2003, 2012 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: CallStackPerThread.java,v 1.4 2006/02/08 19:56:55 slavescu Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 * 
 * $Id: CallStackPerThread.java,v 1.4 2006/02/08 19:56:55 slavescu Exp $
 **********************************************************************/
package org.eclipse.hyades.loaders.trace;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;


/**
 * The current call stack for a thread. 
 * This class was a stack, but has been changed
 * to an ArrayList. Stack extends Vector, which is synchronized, while ArrayList does not.
 *
 * @author slavescu
 *
 */
public class CallStackPerThread extends ArrayListStack {
	/**
	 * 
	 */
	private static final long serialVersionUID = 3762818177448293939L;
	protected Map<EObject, Object> locks=new HashMap<EObject, Object>();
	protected Map<EObject, Object> locksInherited=new HashMap<EObject, Object>();
	protected TraceUtils.InvocationPool	invocationPool=new TraceUtils.InvocationPool();
	
//	public Map getLocks() {
//		return locks;
//	}
//
//	public Map getLocksInherited() {
//		return locksInherited;
//	}

//	public TraceUtils.InvocationPool getInvocationPool() {
//		return invocationPool;
//	}
//
//	public void setInvocationPool(TraceUtils.InvocationPool pool) {
//		invocationPool = pool;
//	}

//	public void setLocks(Map map) {
//		locks = map;
//	}
//
//	public void setLocksInherited(Map map) {
//		locksInherited = map;
//	}

}


@SuppressWarnings("rawtypes")
class ArrayListStack extends ArrayList {
	
	private static final long serialVersionUID = -5698821897251957431L;

	@SuppressWarnings("unchecked")
	public Object push(Object item) {
		add(item);
		return item;
	}
	
	public Object peek() {
		return get(size()-1); 
	}
	
	public Object pop() {
		return remove(size()-1);
	}
	
	public boolean empty() {
		return size() == 0;
	}
}
