/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: CFGCategorySelectionMode.java,v 1.8 2009-05-05 15:46:21 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.common.configuration;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>CFG Category Selection Mode</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGCategorySelectionMode()
 * @model
 * @generated
 */
public enum CFGCategorySelectionMode implements Enumerator
{
	/**
	 * The '<em><b>Enter Value</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Enter Value</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #ENTER_VALUE
	 * @generated
	 * @ordered
	 */
	ENTER_VALUE_LITERAL(0, "enterValue", "enterValue"),
	/**
	 * The '<em><b>Select And Enter Value</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Select And Enter Value</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SELECT_AND_ENTER_VALUE
	 * @generated
	 * @ordered
	 */
	SELECT_AND_ENTER_VALUE_LITERAL(1, "selectAndEnterValue", "selectAndEnterValue"),
	/**
	 * The '<em><b>Select Value</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Select Value</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SELECT_VALUE
	 * @generated
	 * @ordered
	 */
	SELECT_VALUE_LITERAL(2, "selectValue", "selectValue"),
	/**
	 * The '<em><b>Password</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Password</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #PASSWORD
	 * @generated
	 * @ordered
	 */
	PASSWORD_LITERAL(3, "password", "password");
	/**
	 * The '<em><b>Enter Value</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #ENTER_VALUE_LITERAL
	 * @model name="enterValue"
	 * @generated
	 * @ordered
	 */
	public static final int ENTER_VALUE = 0;

	/**
	 * The '<em><b>Select And Enter Value</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SELECT_AND_ENTER_VALUE_LITERAL
	 * @model name="selectAndEnterValue"
	 * @generated
	 * @ordered
	 */
	public static final int SELECT_AND_ENTER_VALUE = 1;

	/**
	 * The '<em><b>Select Value</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SELECT_VALUE_LITERAL
	 * @model name="selectValue"
	 * @generated
	 * @ordered
	 */
	public static final int SELECT_VALUE = 2;

	/**
	 * The '<em><b>Password</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #PASSWORD_LITERAL
	 * @model name="password"
	 * @generated
	 * @ordered
	 */
	public static final int PASSWORD = 3;

	/**
	 * An array of all the '<em><b>CFG Category Selection Mode</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final CFGCategorySelectionMode[] VALUES_ARRAY =
		new CFGCategorySelectionMode[] {
			ENTER_VALUE_LITERAL,
			SELECT_AND_ENTER_VALUE_LITERAL,
			SELECT_VALUE_LITERAL,
			PASSWORD_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>CFG Category Selection Mode</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<CFGCategorySelectionMode> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>CFG Category Selection Mode</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static CFGCategorySelectionMode get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			CFGCategorySelectionMode result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>CFG Category Selection Mode</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static CFGCategorySelectionMode getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			CFGCategorySelectionMode result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>CFG Category Selection Mode</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static CFGCategorySelectionMode get(int value) {
		switch (value) {
			case ENTER_VALUE: return ENTER_VALUE_LITERAL;
			case SELECT_AND_ENTER_VALUE: return SELECT_AND_ENTER_VALUE_LITERAL;
			case SELECT_VALUE: return SELECT_VALUE_LITERAL;
			case PASSWORD: return PASSWORD_LITERAL;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private CFGCategorySelectionMode(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
}
