/**********************************************************************
 * Copyright (c) 2011 IBM Corporation
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: 
 **********************************************************************/
package org.eclipse.hyades.models.trace;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TRC Memory Stats Manager</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCMemoryStatsManager#getNumFullMethInvocObjs <em>Num Full Meth Invoc Objs</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCMemoryStatsManager#getNumAggMethInvocObjs <em>Num Agg Meth Invoc Objs</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCMemoryStatsManager#getNumHeapObjs <em>Num Heap Objs</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCMemoryStatsManager()
 * @model
 * @generated
 */
public interface TRCMemoryStatsManager extends EObject {
	/**
	 * Returns the value of the '<em><b>Num Full Meth Invoc Objs</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Num Full Meth Invoc Objs</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Num Full Meth Invoc Objs</em>' attribute.
	 * @see #setNumFullMethInvocObjs(long)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCMemoryStatsManager_NumFullMethInvocObjs()
	 * @model
	 * @generated
	 */
	long getNumFullMethInvocObjs();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCMemoryStatsManager#getNumFullMethInvocObjs <em>Num Full Meth Invoc Objs</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Num Full Meth Invoc Objs</em>' attribute.
	 * @see #getNumFullMethInvocObjs()
	 * @generated
	 */
	void setNumFullMethInvocObjs(long value);

	/**
	 * Returns the value of the '<em><b>Num Agg Meth Invoc Objs</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Num Agg Meth Invoc Objs</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Num Agg Meth Invoc Objs</em>' attribute.
	 * @see #setNumAggMethInvocObjs(long)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCMemoryStatsManager_NumAggMethInvocObjs()
	 * @model
	 * @generated
	 */
	long getNumAggMethInvocObjs();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCMemoryStatsManager#getNumAggMethInvocObjs <em>Num Agg Meth Invoc Objs</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Num Agg Meth Invoc Objs</em>' attribute.
	 * @see #getNumAggMethInvocObjs()
	 * @generated
	 */
	void setNumAggMethInvocObjs(long value);

	/**
	 * Returns the value of the '<em><b>Num Heap Objs</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Num Heap Objs</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Num Heap Objs</em>' attribute.
	 * @see #setNumHeapObjs(long)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCMemoryStatsManager_NumHeapObjs()
	 * @model
	 * @generated
	 */
	long getNumHeapObjs();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCMemoryStatsManager#getNumHeapObjs <em>Num Heap Objs</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Num Heap Objs</em>' attribute.
	 * @see #getNumHeapObjs()
	 * @generated
	 */
	void setNumHeapObjs(long value);

} // TRCMemoryStatsManager
