/**********************************************************************
 * Copyright (c) 2008 Intel Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Intel - Initial API and implementation
 *
 * $Id: TRCThreadHandoffLockEvent.java,v 1.2 2008-03-12 20:23:10 jkubasta Exp $
 **********************************************************************/
package org.eclipse.hyades.models.trace;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TRC Thread Handoff Lock Event</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCThreadHandoffLockEvent#getLockedObject <em>Locked Object</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCThreadHandoffLockEvent()
 * @model
 * @generated
 */
public interface TRCThreadHandoffLockEvent extends TRCThreadExecEvent {
	/**
	 * Returns the value of the '<em><b>Locked Object</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Locked Object</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Locked Object</em>' reference.
	 * @see #setLockedObject(TRCObject)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCThreadHandoffLockEvent_LockedObject()
	 * @model required="true"
	 * @generated
	 */
	TRCObject getLockedObject();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCThreadHandoffLockEvent#getLockedObject <em>Locked Object</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Locked Object</em>' reference.
	 * @see #getLockedObject()
	 * @generated
	 */
	void setLockedObject(TRCObject value);

} // TRCThreadHandoffLockEvent