/**********************************************************************
 * Copyright (c) 2008 Intel Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Intel - Initial API and implementation
 *
 * $Id: TRCThreadInterruptThreadEvent.java,v 1.2 2008-03-12 20:23:10 jkubasta Exp $
 **********************************************************************/
package org.eclipse.hyades.models.trace;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TRC Thread Interrupt Thread Event</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCThreadInterruptThreadEvent#getInterruptedThread <em>Interrupted Thread</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCThreadInterruptThreadEvent()
 * @model
 * @generated
 */
public interface TRCThreadInterruptThreadEvent extends TRCThreadExecEvent {
	/**
	 * Returns the value of the '<em><b>Interrupted Thread</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interrupted Thread</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Interrupted Thread</em>' reference.
	 * @see #setInterruptedThread(TRCThread)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCThreadInterruptThreadEvent_InterruptedThread()
	 * @model
	 * @generated
	 */
	TRCThread getInterruptedThread();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCThreadInterruptThreadEvent#getInterruptedThread <em>Interrupted Thread</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Interrupted Thread</em>' reference.
	 * @see #getInterruptedThread()
	 * @generated
	 */
	void setInterruptedThread(TRCThread value);

} // TRCThreadInterruptThreadEvent