/**********************************************************************
 * Copyright (c) 2011 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: 
 **********************************************************************/
package org.eclipse.hyades.models.trace.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.hyades.models.trace.TRCClass;
import org.eclipse.hyades.models.trace.TRCMethod;
import org.eclipse.hyades.models.trace.TRCObjAllocSite;
import org.eclipse.hyades.models.trace.TracePackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>TRC Obj Alloc Site</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.trace.impl.TRCObjAllocSiteImpl#getMethod <em>Method</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.impl.TRCObjAllocSiteImpl#getClass_ <em>Class</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.impl.TRCObjAllocSiteImpl#getLineNumber <em>Line Number</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.impl.TRCObjAllocSiteImpl#getObjectsCreated <em>Objects Created</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class TRCObjAllocSiteImpl extends EObjectImpl implements TRCObjAllocSite {
	/**
	 * The cached value of the '{@link #getMethod() <em>Method</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMethod()
	 * @generated
	 * @ordered
	 */
	protected TRCMethod method;
	/**
	 * The default value of the '{@link #getLineNumber() <em>Line Number</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLineNumber()
	 * @generated
	 * @ordered
	 */
	protected static final int LINE_NUMBER_EDEFAULT = 0;
	/**
	 * The cached value of the '{@link #getLineNumber() <em>Line Number</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLineNumber()
	 * @generated
	 * @ordered
	 */
	protected int lineNumber = LINE_NUMBER_EDEFAULT;

	/**
	 * The default value of the '{@link #getObjectsCreated() <em>Objects Created</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getObjectsCreated()
	 * @generated
	 * @ordered
	 */
	protected static final long OBJECTS_CREATED_EDEFAULT = 0L;
	/**
	 * The cached value of the '{@link #getObjectsCreated() <em>Objects Created</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getObjectsCreated()
	 * @generated
	 * @ordered
	 */
	protected long objectsCreated = OBJECTS_CREATED_EDEFAULT;
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TRCObjAllocSiteImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return TracePackage.Literals.TRC_OBJ_ALLOC_SITE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TRCMethod getMethod() {
		if (method != null && method.eIsProxy()) {
			InternalEObject oldMethod = (InternalEObject)method;
			method = (TRCMethod)eResolveProxy(oldMethod);
			if (method != oldMethod) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, TracePackage.TRC_OBJ_ALLOC_SITE__METHOD, oldMethod, method));
			}
		}
		return method;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TRCMethod basicGetMethod() {
		return method;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMethod(TRCMethod newMethod) {
		TRCMethod oldMethod = method;
		method = newMethod;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TracePackage.TRC_OBJ_ALLOC_SITE__METHOD, oldMethod, method));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TRCClass getClass_() {
		if (eContainerFeatureID() != TracePackage.TRC_OBJ_ALLOC_SITE__CLASS) return null;
		return (TRCClass)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetClass(TRCClass newClass, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newClass, TracePackage.TRC_OBJ_ALLOC_SITE__CLASS, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setClass(TRCClass newClass) {
		if (newClass != eInternalContainer() || (eContainerFeatureID() != TracePackage.TRC_OBJ_ALLOC_SITE__CLASS && newClass != null)) {
			if (EcoreUtil.isAncestor(this, newClass))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newClass != null)
				msgs = ((InternalEObject)newClass).eInverseAdd(this, TracePackage.TRC_CLASS__ALLOCATION_SITES, TRCClass.class, msgs);
			msgs = basicSetClass(newClass, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TracePackage.TRC_OBJ_ALLOC_SITE__CLASS, newClass, newClass));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getLineNumber() {
		return lineNumber;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLineNumber(int newLineNumber) {
		int oldLineNumber = lineNumber;
		lineNumber = newLineNumber;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TracePackage.TRC_OBJ_ALLOC_SITE__LINE_NUMBER, oldLineNumber, lineNumber));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public long getObjectsCreated() {
		return objectsCreated;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setObjectsCreated(long newObjectsCreated) {
		long oldObjectsCreated = objectsCreated;
		objectsCreated = newObjectsCreated;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TracePackage.TRC_OBJ_ALLOC_SITE__OBJECTS_CREATED, oldObjectsCreated, objectsCreated));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case TracePackage.TRC_OBJ_ALLOC_SITE__CLASS:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetClass((TRCClass)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case TracePackage.TRC_OBJ_ALLOC_SITE__CLASS:
				return basicSetClass(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case TracePackage.TRC_OBJ_ALLOC_SITE__CLASS:
				return eInternalContainer().eInverseRemove(this, TracePackage.TRC_CLASS__ALLOCATION_SITES, TRCClass.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case TracePackage.TRC_OBJ_ALLOC_SITE__METHOD:
				if (resolve) return getMethod();
				return basicGetMethod();
			case TracePackage.TRC_OBJ_ALLOC_SITE__CLASS:
				return getClass_();
			case TracePackage.TRC_OBJ_ALLOC_SITE__LINE_NUMBER:
				return getLineNumber();
			case TracePackage.TRC_OBJ_ALLOC_SITE__OBJECTS_CREATED:
				return getObjectsCreated();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case TracePackage.TRC_OBJ_ALLOC_SITE__METHOD:
				setMethod((TRCMethod)newValue);
				return;
			case TracePackage.TRC_OBJ_ALLOC_SITE__CLASS:
				setClass((TRCClass)newValue);
				return;
			case TracePackage.TRC_OBJ_ALLOC_SITE__LINE_NUMBER:
				setLineNumber((Integer)newValue);
				return;
			case TracePackage.TRC_OBJ_ALLOC_SITE__OBJECTS_CREATED:
				setObjectsCreated((Long)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case TracePackage.TRC_OBJ_ALLOC_SITE__METHOD:
				setMethod((TRCMethod)null);
				return;
			case TracePackage.TRC_OBJ_ALLOC_SITE__CLASS:
				setClass((TRCClass)null);
				return;
			case TracePackage.TRC_OBJ_ALLOC_SITE__LINE_NUMBER:
				setLineNumber(LINE_NUMBER_EDEFAULT);
				return;
			case TracePackage.TRC_OBJ_ALLOC_SITE__OBJECTS_CREATED:
				setObjectsCreated(OBJECTS_CREATED_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case TracePackage.TRC_OBJ_ALLOC_SITE__METHOD:
				return method != null;
			case TracePackage.TRC_OBJ_ALLOC_SITE__CLASS:
				return getClass_() != null;
			case TracePackage.TRC_OBJ_ALLOC_SITE__LINE_NUMBER:
				return lineNumber != LINE_NUMBER_EDEFAULT;
			case TracePackage.TRC_OBJ_ALLOC_SITE__OBJECTS_CREATED:
				return objectsCreated != OBJECTS_CREATED_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (lineNumber: ");
		result.append(lineNumber);
		result.append(", objectsCreated: ");
		result.append(objectsCreated);
		result.append(')');
		return result.toString();
	}

} //TRCObjAllocSiteImpl
