/*******************************************************************************
 * Copyright (c) 2005, 2012 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.hyades.trace.views.internal.context.java.formatters;

import java.util.List;

import org.eclipse.hyades.models.trace.TRCThread;
import org.eclipse.hyades.trace.ui.internal.util.PerftraceUtil;
import org.eclipse.hyades.trace.ui.internal.util.TraceMessages;
import org.eclipse.hyades.ui.provisional.context.IContextLabelFormatProvider;

public class ThreadNameAttrLP extends AttrLPAdapter {

	public String getDisplayStringFromElement(Object value, Object element, int mode) {
		if (mode == IContextLabelFormatProvider.MODE_VIEW_FILTER)
			return TraceMessages.ST_FPTN;
		else if (mode == IContextLabelFormatProvider.MODE_COLUMN_HEADER)
			return TraceMessages.ST_FPTN;
		else if (mode == IContextLabelFormatProvider.MODE_COLUMN_CONTENT)
		{
			if (element instanceof TRCThread)
				return PerftraceUtil.getThreadName((TRCThread)element);
			else if (value instanceof String)
				return (String)value;
		}
		
		return "";
	}
	
	protected List<Integer> internalSupportModes()
	{
		List<Integer> modes = super.internalSupportModes();
		modes.add(new Integer(IContextLabelFormatProvider.MODE_COLUMN_CONTENT));
		modes.add(new Integer(IContextLabelFormatProvider.MODE_COLUMN_HEADER));
		modes.add(new Integer(IContextLabelFormatProvider.MODE_VIEW_FILTER));
		
		return modes;
	}	
}
