/**********************************************************************
 * Copyright (c) 2006 Intel Corporation.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: AggregatedMaxTimeColumnLabel.java,v 1.2 2006-10-11 22:11:11 ewchan Exp $
 * 
 **********************************************************************/
package org.eclipse.hyades.trace.views.internal.view.columnlabels;

import org.eclipse.hyades.trace.ui.internal.util.TString;
import org.eclipse.hyades.trace.views.util.internal.AggregatedInvocation;
import org.eclipse.hyades.ui.provisional.context.IContextAttributes;
import org.eclipse.swt.graphics.Image;

public class AggregatedMaxTimeColumnLabel extends AbstractNumberColumnLabel {

	protected Number getValue(Object element, ColumnDisplayInfo info) {
		if (element instanceof AggregatedInvocation) {
			return new Double(((AggregatedInvocation)element).getMaxTime()); 
		}
		return null;
	}

	public String getDisplayString(Object element, ColumnDisplayInfo info) {
		Number value = getValue(element, info);
		return value != null ? TString.formatTimeValue(value.doubleValue()) : "";
	}
	
	public Image getDisplayImage(Object element, ColumnDisplayInfo info) {
		return null;
	}

	protected String getContextAttribute(Object element, ColumnDisplayInfo info) {
		return IContextAttributes.METHOD_MAX_TIME;
	}


	protected Number getDelta(Object element, ColumnDisplayInfo info) {
		return null;
	}


}
