/**********************************************************************
 * Copyright (c) 2005, 2012 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: DateComparator.java,v 1.1 2005-07-22 14:49:35 hleung Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.uml2sd.trace.loaders.internal;

import java.util.Comparator;

import org.eclipse.hyades.uml2sd.trace.selection.IDateSelection;

/**
 * This class is intended to compare DateSelection items
 */
public class DateComparator implements Comparator<Object> {

	public int compare(Object arg0, Object arg1) {
		if (arg0 instanceof IDateSelection && arg1 instanceof IDateSelection) {
			IDateSelection t1 = (IDateSelection) arg0;
			IDateSelection t2 = (IDateSelection) arg1;
			if (t1.getStartDate() > t2.getStartDate())
				return 1;
			else if (t1.getStartDate() == t2.getStartDate())
				return 0;
			else
				return -1;
		} else
			return 0;
	}

}
