/**********************************************************************
 * Copyright (c) 2012 IBM Corporation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.tptp.platform.common.internal;

public class GenericAttachableAgent {
	private int _port;
	private String _uuid;
	private String _name;
	
	/** Optional */
	private int _pid;
	
	public int getPort() {
		return _port;
	}
	
	public void setPort(int port) {
		this._port = port;
	}
	
	public String getUuid() {
		return _uuid;
	}
	
	public void setUuid(String uuid) {
		this._uuid = uuid;
	}
	
	public String getName() {
		return _name;
	}
	
	public void setName(String name) {
		this._name = name;
	}
	
	public int getPid() {
		return _pid;
	}
	
	public void setPid(int pid) {
		this._pid = pid;
	}

	@Override
	public boolean equals(Object o) {
		if(!(o instanceof GenericAttachableAgent)) {
			return false;
		}
		GenericAttachableAgent a = (GenericAttachableAgent)o;
		
		return stringEqual(a.getName(), getName()) &&
				stringEqual(a.getUuid(), getUuid()) &&
				a.getPort() == getPort() && a.getPid() == getPid();
	}
	
	private boolean stringEqual(String one, String two) {
		if(one == null || two == null) {
			return one == two;
		}
		
		return one.equals(two);
		
	}
	
}
