/**********************************************************************
 * Copyright (c) 2006, 2012 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.tptp.platform.jvmti.client.internal.launcher;

import org.eclipse.tptp.platform.jvmti.client.internal.ITILaunchConfigurationConstants;
import org.eclipse.tptp.trace.ui.internal.launcher.application.AbstractConfiguration;
import org.eclipse.tptp.trace.ui.internal.launcher.application.FilterConfigurationPage;
import org.eclipse.tptp.trace.ui.internal.launcher.application.LimitsConfigurationPage;


/**
 * The configuration wizard for the TI data collector.  
 * 
 * @author Ali Mehregani
 */
public class TIConfiguration extends AbstractConfiguration
{

	/**
	 * Default constructor - Adds the filter page.
	 */
	public TIConfiguration()
	{
		super(new Class[]{TIFilterConfigurationPage.class, TILimitsConfigurationPage.class});	
	}

	
	/**
	 * This is the filter configuration page that will be displayed in 
	 * the configuration wizard for the TI data collector.
	 * 
	 * @author Ali Mehregani
	 */
	public static class TIFilterConfigurationPage extends FilterConfigurationPage
	{			
		public TIFilterConfigurationPage ()
		{
			super(ITILaunchConfigurationConstants.ATTR_FILTERSET_ID);
		}
	}
	/**
	 * This is a limits configuration page that will be displayed in the
	 * configuration wizard for the TI data collector
	 */
	public static class TILimitsConfigurationPage extends LimitsConfigurationPage{
		
		public TILimitsConfigurationPage ()
		{
			super ();
		}
		
	}
}
