/* ***********************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: UnitDefinition.java,v 1.1 2005-03-30 08:26:42 dguilbaud Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: UnitDefinition.java,v 1.1 2005-03-30 08:26:42 dguilbaud Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.tptp.platform.report.chart.svg.internal.input;

import org.w3c.dom.Element;



/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Unit Definition</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.UnitDefinition#isShowGridLine <em>Show Grid Line</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.UnitDefinition#isShowTick <em>Show Tick</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.UnitDefinition#getValue <em>Value</em>}</li>
 * </ul>
 * </p>
 *
 * @model 
 * @generated
 */
public interface UnitDefinition {
	/**
	 * Returns the value of the '<em><b>Show Grid Line</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Show Grid Line</em>' attribute.
	 * @see #isSetShowGridLine()
	 * @see #unsetShowGridLine()
	 * @see #setShowGridLine(boolean)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getUnitDefinition_ShowGridLine()
	 * @model unsettable="true"
	 * @generated
	 */
	boolean isShowGridLine();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.UnitDefinition#isShowGridLine <em>Show Grid Line</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Show Grid Line</em>' attribute.
	 * @see #isSetShowGridLine()
	 * @see #unsetShowGridLine()
	 * @see #isShowGridLine()
	 * @generated
	 */
	void setShowGridLine(boolean value);

	/**
	 * Unsets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.UnitDefinition#isShowGridLine <em>Show Grid Line</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetShowGridLine()
	 * @see #isShowGridLine()
	 * @see #setShowGridLine(boolean)
	 * @generated
	 */
	void unsetShowGridLine();

	/**
	 * Returns whether the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.UnitDefinition#isShowGridLine <em>Show Grid Line</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Show Grid Line</em>' attribute is set.
	 * @see #unsetShowGridLine()
	 * @see #isShowGridLine()
	 * @see #setShowGridLine(boolean)
	 * @generated
	 */
	boolean isSetShowGridLine();

	/**
	 * Returns the value of the '<em><b>Show Tick</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Show Tick</em>' attribute.
	 * @see #isSetShowTick()
	 * @see #unsetShowTick()
	 * @see #setShowTick(boolean)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getUnitDefinition_ShowTick()
	 * @model unsettable="true"
	 * @generated
	 */
	boolean isShowTick();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.UnitDefinition#isShowTick <em>Show Tick</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Show Tick</em>' attribute.
	 * @see #isSetShowTick()
	 * @see #unsetShowTick()
	 * @see #isShowTick()
	 * @generated
	 */
	void setShowTick(boolean value);

	/**
	 * Unsets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.UnitDefinition#isShowTick <em>Show Tick</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetShowTick()
	 * @see #isShowTick()
	 * @see #setShowTick(boolean)
	 * @generated
	 */
	void unsetShowTick();

	/**
	 * Returns whether the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.UnitDefinition#isShowTick <em>Show Tick</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Show Tick</em>' attribute is set.
	 * @see #unsetShowTick()
	 * @see #isShowTick()
	 * @see #setShowTick(boolean)
	 * @generated
	 */
	boolean isSetShowTick();

	/**
	 * Returns the value of the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Value</em>' attribute.
	 * @see #isSetValue()
	 * @see #unsetValue()
	 * @see #setValue(double)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getUnitDefinition_Value()
	 * @model unsettable="true"
	 * @generated
	 */
	double getValue();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.UnitDefinition#getValue <em>Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Value</em>' attribute.
	 * @see #isSetValue()
	 * @see #unsetValue()
	 * @see #getValue()
	 * @generated
	 */
	void setValue(double value);

	/**
	 * Unsets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.UnitDefinition#getValue <em>Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetValue()
	 * @see #getValue()
	 * @see #setValue(double)
	 * @generated
	 */
	void unsetValue();

	/**
	 * Returns whether the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.UnitDefinition#getValue <em>Value</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Value</em>' attribute is set.
	 * @see #unsetValue()
	 * @see #getValue()
	 * @see #setValue(double)
	 * @generated
	 */
	boolean isSetValue();

	/**
	 * Returns the document object element of this object. 
	 * If this object was not initialized with an element, null will be returned.
	 * @return the element in the DOM represented by this object
	 */
	public Element getElement(); 

} // UnitDefinition
