/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: DData.java,v 1.2 2008-05-23 14:11:47 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/


package org.eclipse.tptp.platform.report.core.internal;


/**
 * A DData is a class to set user data in a document hierarchy. A user data is a 
 * reference to a Java object (inherits of Object class).
 * 
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 * 
 */
public class DData extends DItem implements IDParagraphItem, IDBasicItem 
{
   private Object data = null;
   
   /**
    * Creates a user data object with a null reference.
    */
   public DData() 
   {
    
   }
   
   /**
    * Creates a user data object and references an object passed in parameter.
    */
   public DData(Object d) 
   {
    
   }
   
   /**
    * Access method for the data property.
    * 
    * @return   the current value of the data property
    */
   public java.lang.Object getData() 
   {
      return data;
   }
   
   /**
    * Sets the value of the data property.
    * 
    * @param aData the new value of the data property
    */
   public void setData(java.lang.Object aData) 
   {
      data = aData;
   }
}
