/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: DPreferences.java,v 1.2 2008-05-23 14:11:47 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/


package org.eclipse.tptp.platform.report.core.internal;

/**
 * This interface provides the properties for the preferences
 * information.
 * 
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 * 
 */
public class DPreferences extends DItem {
    
    private String url;
    private String tooltip;
    private boolean show = false;
    private String browserCookieName;
    private String updatedPreferencesVariable;
    private String storedPreferences;
     
    /** creates a new preference object.
     */
    public DPreferences() {}
    
    /** @return true if the preferences should be displayed for the chart*/
    public boolean isShow() {
        return show;
    }
    
    /** sets the showing property for the preferences for the chart */
    public void setShow(boolean show) {
        this.show = show;
    }
    
    /** @return the browser cookie name */
    public String getBrowserCookieName() {
        return browserCookieName;
    }
    
    /** sets the browser cookie name */
    public void setBrowserCookieName(String browserCookieName) {
        this.browserCookieName = browserCookieName;
    }
    
    /** @return the stored preferences */
    public String getStoredPreferences() {
        return storedPreferences;
    }
    
    /** sets the stored preferences */
    public void setStoredPreferences(String storedPreferences) {
        this.storedPreferences = storedPreferences;
    }
    
    /** @return the tooltip for the preference open button */
    public String getTooltip() {
        return tooltip;
    }
    
    /** sets the tooltip */
    public void setTooltip(String tooltip) {
        this.tooltip = tooltip;
    }
    
    /** @return the preference variable */
    public String getUpdatedPreferencesVariable() {
        return updatedPreferencesVariable;
    }
    
    /** sets the preference variables */
    public void setUpdatedPreferencesVariable(String updatedPreferencesVariable) {
        this.updatedPreferencesVariable = updatedPreferencesVariable;
    }
    
    /** @return the url */
    public String getUrl() {
        return url;
    }
    
    /** sets the url */
    public void setUrl(String url) {
        this.url = url;
    }
}
