/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IDDocument.java,v 1.2 2008-05-23 14:11:47 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/



package org.eclipse.tptp.platform.report.core.internal;


/**
 * Provides an interface for the JScrib documents.
 * 
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 * 
 */
public interface IDDocument extends IDTaggedItem, IDItem 
{
   
   /**
    * @return the document title. This title is used by the driver to
    * set a Job name, a window title, etc...
    */
   public String getTitle();
   
   /**
    * Sets the document title to 't'
    */
   public void setTitle(String t);
   
   /** @return the root IDItem of the document */
   public IDItem getDocument();
  
}
