/*******************************************************************************
 * Copyright (c) 2005, 2006 IBM,Intel Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Guru Nagarajan, Intel - initial API and implementation
 *    IBM - Initial Java API and implementation
 *
 * $Id: GetAgentCommand.h,v 1.5 2006-02-10 19:54:16 vnaikawadi Exp $
 *
 *******************************************************************************/ 


#ifndef GETAGENTCOMMAND_H
#define GETAGENTCOMMAND_H

#include "tptp/TPTPExport.h"
#include "tptp/client/CommandElement.h"
#include "tptp/client/TPTP_String.h"


using namespace std;

class TPTP_CLASS_EXPORT GetAgentCommand: public CommandElement
{
	protected:
		TPTP_String* agentName;
		TPTP_String* agentInterface;
		unsigned int createNew;
		
	private:
		TPTP_String* commandName;
		TPTP_String* commandData;
		TPTP_String* command;

	public:
		GetAgentCommand(string aName,unsigned int create);
		GetAgentCommand(string aName);
		void buildCommand();
		string getCommand();
		virtual unsigned int getSize();

		void setCommandName(string cmdName);
		string getCommandName();

		void setCommandData(string cmdData);
		string getCommandData();


		virtual unsigned char* readFromBuffer(unsigned char *buffer,unsigned int offset);
		virtual unsigned char* writeToBuffer(unsigned char *buffer,unsigned int offset);

		void parseBuffer(char *buffer);
};


#endif


