/************************************************************************
* Copyright (c) 2017 IBM.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*    IBM - Initial API and implementation
*    Anton Karputkin, IBM - Initial API and implementation
*
* $Id: ExceptionCatchEvent.h,v 1.0 2017-04-05 14:44:00 antonk Exp $
************************************************************************/

#ifndef _EXCEPTION_CATCH_EVENT_H_
#define _EXCEPTION_CATCH_EVENT_H_

#include "MpiAPI.h"
#include "ProfEnv.h"
#include "Tickets.h"
#include "log.h"

namespace Martini {
	namespace CGProf {

		// CNewThrowableEvent - represents a selective enter method event 
		class CExceptionCatchEvent : public MPI::IExceptionCatchEventObserver
		{
		public:
			// Constructor
			CExceptionCatchEvent();
			// Destructor
			~CExceptionCatchEvent();
			// Initializes internal data and registers for new throwable event
			TResult Init(BaseProf::CProfEnv* profEnv);
			// Inherited methods
			void HandleEvent(MPI::SExceptionCatchEventData &data);
			MPI::BitSet EventDataTypes();

		private:
			// profiler environment
			BaseProf::CProfEnv* m_pProfEnv;
		};

	} /*namespace Martini*/
} /*namespace CGProf*/

#endif // _EXCEPTION_CATCH_EVENT_H_