/*****************************************************************************
 * Copyright (c) 2009, Intel Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Intel Corporation - Initial API and implementation
 *
 * $Id: ThreadLocalStorage.cpp,v 1.1 2009-04-14 20:33:46 jwest Exp $ 
 *****************************************************************************/

#ifdef EM64T_ARCH
#pragma runtime_checks( "", off )
#endif

#include "OSAL.h"

Martini::OSA::CThreadLocalStorage::CThreadLocalStorage()
{
}

Martini::OSA::CThreadLocalStorage::~CThreadLocalStorage()
{
	pthread_key_delete(m_tlsIndex);
}


void* Martini::OSA::CThreadLocalStorage::GetValue()
{
    return pthread_getspecific(m_tlsIndex);
}

void Martini::OSA::CThreadLocalStorage::SetValue(void* pValue)
{
	pthread_setspecific(m_tlsIndex, pValue);
}

TResult Martini::OSA::CThreadLocalStorage::Destroy()
{
    delete this;
    return MRTE_RESULT_OK;
}


TResult Martini::OSA::CThreadLocalStorage::Create()
{
    int iRetVal = pthread_key_create(&m_tlsIndex, NULL);

    if(iRetVal != 0) 
    {
        return MRTE_RESULT_FALSE;
    }
    return MRTE_RESULT_OK;
}

