/**********************************************************************
 * Copyright (c) 2005, 2012 IBM Corporation, Intel Corporation.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ReconnectRequestedException.java,v 1.1 2006-08-30 17:38:59 akaylor Exp $
 *
 * Contributors:
 * 	  Andy Kaylor,Intel - Initial implementation
 **********************************************************************/

package org.eclipse.tptp.platform.execution.exceptions;

public class ReconnectRequestedException extends Exception {
	private static final long serialVersionUID = 1L;
	int _port;
	
	public ReconnectRequestedException(int port) {
		_port = port;
	}

	public ReconnectRequestedException( int port, String message )
	{
		super(message);
		_port = port;
	}
	
	public int getReconnectPort() {
		return _port;
	}
}
