/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: Common_ConfigurationPackage.java,v 1.8 2009-05-05 15:46:22 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.common.configuration;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.hyades.models.common.common.CommonPackage;
import org.eclipse.hyades.models.common.interactions.Common_Behavior_InteractionsPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationFactory
 * @model kind="package"
 * @generated
 */
public interface Common_ConfigurationPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "configuration";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.eclipse.org/hyades/models/common/configuration.xmi";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "Common_Configuration";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	Common_ConfigurationPackage eINSTANCE = org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGConfigurableObjectImpl <em>CFG Configurable Object</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.CFGConfigurableObjectImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGConfigurableObject()
	 * @generated
	 */
	int CFG_CONFIGURABLE_OBJECT = 30;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_CONFIGURABLE_OBJECT__ID = CommonPackage.CMN_NAMED_ELEMENT__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_CONFIGURABLE_OBJECT__DESCRIPTION = CommonPackage.CMN_NAMED_ELEMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_CONFIGURABLE_OBJECT__NAME = CommonPackage.CMN_NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Property Groups</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_CONFIGURABLE_OBJECT__PROPERTY_GROUPS = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>CFG Configurable Object</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_CONFIGURABLE_OBJECT_FEATURE_COUNT = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGLocationImpl <em>CFG Location</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.CFGLocationImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGLocation()
	 * @generated
	 */
	int CFG_LOCATION = 0;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_LOCATION__ID = CFG_CONFIGURABLE_OBJECT__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_LOCATION__DESCRIPTION = CFG_CONFIGURABLE_OBJECT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_LOCATION__NAME = CFG_CONFIGURABLE_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Property Groups</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_LOCATION__PROPERTY_GROUPS = CFG_CONFIGURABLE_OBJECT__PROPERTY_GROUPS;

	/**
	 * The feature id for the '<em><b>Deployment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_LOCATION__DEPLOYMENT = CFG_CONFIGURABLE_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Timezone</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_LOCATION__TIMEZONE = CFG_CONFIGURABLE_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Sub Locations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_LOCATION__SUB_LOCATIONS = CFG_CONFIGURABLE_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_LOCATION__PARENT = CFG_CONFIGURABLE_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Ref Sub Locations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_LOCATION__REF_SUB_LOCATIONS = CFG_CONFIGURABLE_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>CFG Location</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_LOCATION_FEATURE_COUNT = CFG_CONFIGURABLE_OBJECT_FEATURE_COUNT + 5;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGClassImpl <em>CFG Class</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.CFGClassImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGClass()
	 * @generated
	 */
	int CFG_CLASS = 1;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_CLASS__ID = CommonPackage.CMN_NAMED_ELEMENT__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_CLASS__DESCRIPTION = CommonPackage.CMN_NAMED_ELEMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_CLASS__NAME = CommonPackage.CMN_NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Operations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_CLASS__OPERATIONS = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Instances</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_CLASS__INSTANCES = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Instantiations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_CLASS__INSTANTIATIONS = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>CFG Class</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_CLASS_FEATURE_COUNT = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGOperationImpl <em>CFG Operation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.CFGOperationImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGOperation()
	 * @generated
	 */
	int CFG_OPERATION = 2;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_OPERATION__ID = CommonPackage.CMN_NAMED_ELEMENT__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_OPERATION__DESCRIPTION = CommonPackage.CMN_NAMED_ELEMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_OPERATION__NAME = CommonPackage.CMN_NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Owning Class</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_OPERATION__OWNING_CLASS = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>CFG Operation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_OPERATION_FEATURE_COUNT = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGArtifactImpl <em>CFG Artifact</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.CFGArtifactImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGArtifact()
	 * @generated
	 */
	int CFG_ARTIFACT = 3;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_ARTIFACT__ID = CFG_CONFIGURABLE_OBJECT__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_ARTIFACT__DESCRIPTION = CFG_CONFIGURABLE_OBJECT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_ARTIFACT__NAME = CFG_CONFIGURABLE_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Property Groups</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_ARTIFACT__PROPERTY_GROUPS = CFG_CONFIGURABLE_OBJECT__PROPERTY_GROUPS;

	/**
	 * The feature id for the '<em><b>Deployable Instances</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_ARTIFACT__DEPLOYABLE_INSTANCES = CFG_CONFIGURABLE_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>CFG Artifact</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_ARTIFACT_FEATURE_COUNT = CFG_CONFIGURABLE_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGInstanceImpl <em>CFG Instance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.CFGInstanceImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGInstance()
	 * @generated
	 */
	int CFG_INSTANCE = 4;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_INSTANCE__ID = CommonPackage.CMN_NAMED_ELEMENT__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_INSTANCE__DESCRIPTION = CommonPackage.CMN_NAMED_ELEMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_INSTANCE__NAME = CommonPackage.CMN_NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Lifeline</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_INSTANCE__LIFELINE = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Test Case</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_INSTANCE__TEST_CASE = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Max Count</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_INSTANCE__MAX_COUNT = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Initial Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_INSTANCE__INITIAL_VALUE = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Class Owner</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_INSTANCE__CLASS_OWNER = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Class Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_INSTANCE__CLASS_TYPE = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>CFG Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_INSTANCE_FEATURE_COUNT = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 6;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGComparablePropertyImpl <em>CFG Comparable Property</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.CFGComparablePropertyImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGComparableProperty()
	 * @generated
	 */
	int CFG_COMPARABLE_PROPERTY = 5;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_COMPARABLE_PROPERTY__ID = Common_Behavior_InteractionsPackage.BVR_PROPERTY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_COMPARABLE_PROPERTY__DESCRIPTION = Common_Behavior_InteractionsPackage.BVR_PROPERTY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_COMPARABLE_PROPERTY__NAME = Common_Behavior_InteractionsPackage.BVR_PROPERTY__NAME;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_COMPARABLE_PROPERTY__VALUE = Common_Behavior_InteractionsPackage.BVR_PROPERTY__VALUE;

	/**
	 * The feature id for the '<em><b>Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_COMPARABLE_PROPERTY__TYPE = Common_Behavior_InteractionsPackage.BVR_PROPERTY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_COMPARABLE_PROPERTY__OPERATOR = Common_Behavior_InteractionsPackage.BVR_PROPERTY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Sub Property Groups</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_COMPARABLE_PROPERTY__SUB_PROPERTY_GROUPS = Common_Behavior_InteractionsPackage.BVR_PROPERTY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>CFG Comparable Property</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_COMPARABLE_PROPERTY_FEATURE_COUNT = Common_Behavior_InteractionsPackage.BVR_PROPERTY_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGPropertyGroupImpl <em>CFG Property Group</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.CFGPropertyGroupImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGPropertyGroup()
	 * @generated
	 */
	int CFG_PROPERTY_GROUP = 6;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_PROPERTY_GROUP__ID = CommonPackage.CMN_NAMED_ELEMENT__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_PROPERTY_GROUP__DESCRIPTION = CommonPackage.CMN_NAMED_ELEMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_PROPERTY_GROUP__NAME = CommonPackage.CMN_NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Property Group ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_PROPERTY_GROUP__PROPERTY_GROUP_ID = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Properties</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_PROPERTY_GROUP__PROPERTIES = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Defining Property</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_PROPERTY_GROUP__DEFINING_PROPERTY = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Configurable Object</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_PROPERTY_GROUP__CONFIGURABLE_OBJECT = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>CFG Property Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_PROPERTY_GROUP_FEATURE_COUNT = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGCategoryImpl <em>CFG Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.CFGCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGCategory()
	 * @generated
	 */
	int CFG_CATEGORY = 7;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_CATEGORY__ID = CommonPackage.CMN_NAMED_ELEMENT__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_CATEGORY__DESCRIPTION = CommonPackage.CMN_NAMED_ELEMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_CATEGORY__NAME = CommonPackage.CMN_NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_CATEGORY__DISPLAY_NAME = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_CATEGORY__SELECTION_MODE = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_CATEGORY__SELECTION_AMOUNT = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_CATEGORY__SELECTION_MULTIPLICITY = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>CFG Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_CATEGORY_FEATURE_COUNT = CommonPackage.CMN_NAMED_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGPsudoEnumerationImpl <em>CFG Psudo Enumeration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.CFGPsudoEnumerationImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGPsudoEnumeration()
	 * @generated
	 */
	int CFG_PSUDO_ENUMERATION = 40;

	/**
	 * The feature id for the '<em><b>Values</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_PSUDO_ENUMERATION__VALUES = 0;

	/**
	 * The feature id for the '<em><b>Category</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_PSUDO_ENUMERATION__CATEGORY = 1;

	/**
	 * The number of structural features of the '<em>CFG Psudo Enumeration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_PSUDO_ENUMERATION_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesOperatingSystemEnumerationImpl <em>Hyades Operating System Enumeration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesOperatingSystemEnumerationImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION = 8;

	/**
	 * The feature id for the '<em><b>Values</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__VALUES = CFG_PSUDO_ENUMERATION__VALUES;

	/**
	 * The feature id for the '<em><b>Category</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__CATEGORY = CFG_PSUDO_ENUMERATION__CATEGORY;

	/**
	 * The feature id for the '<em><b>OS 1</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_1 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>OS 2</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_2 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>OS 3</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_3 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>OS 4</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_4 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>OS 5</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_5 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>OS 6</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_6 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>OS 7</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_7 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>OS 8</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_8 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>OS 9</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_9 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>OS 10</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_10 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>OS 11</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_11 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>OS 12</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_12 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 11;

	/**
	 * The feature id for the '<em><b>OS 13</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_13 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 12;

	/**
	 * The feature id for the '<em><b>OS 14</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_14 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 13;

	/**
	 * The feature id for the '<em><b>OS 50</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_50 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 14;

	/**
	 * The feature id for the '<em><b>OS 51</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_51 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 15;

	/**
	 * The feature id for the '<em><b>OS 52</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_52 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 16;

	/**
	 * The feature id for the '<em><b>OS 53</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_53 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 17;

	/**
	 * The feature id for the '<em><b>OS 54</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_54 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 18;

	/**
	 * The feature id for the '<em><b>OS 55</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_55 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 19;

	/**
	 * The feature id for the '<em><b>OS 60</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_60 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 20;

	/**
	 * The feature id for the '<em><b>OS 61</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_61 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 21;

	/**
	 * The feature id for the '<em><b>OS 62</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_62 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 22;

	/**
	 * The feature id for the '<em><b>OS 63</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_63 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 23;

	/**
	 * The feature id for the '<em><b>OS 64</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_64 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 24;

	/**
	 * The feature id for the '<em><b>OS 65</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_65 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 25;

	/**
	 * The feature id for the '<em><b>OS 70</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_70 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 26;

	/**
	 * The feature id for the '<em><b>OS 71</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_71 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 27;

	/**
	 * The feature id for the '<em><b>OS 80</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_80 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 28;

	/**
	 * The feature id for the '<em><b>OS 81</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_81 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 29;

	/**
	 * The feature id for the '<em><b>OS 82</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_82 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 30;

	/**
	 * The feature id for the '<em><b>OS 90</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_90 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 31;

	/**
	 * The feature id for the '<em><b>OS 100</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION__OS_100 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 32;

	/**
	 * The number of structural features of the '<em>Hyades Operating System Enumeration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_ENUMERATION_FEATURE_COUNT = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 33;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesOperatingSystemCategoryImpl <em>Hyades Operating System Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesOperatingSystemCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesOperatingSystemCategory()
	 * @generated
	 */
	int HYADES_OPERATING_SYSTEM_CATEGORY = 9;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Operating System Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_OPERATING_SYSTEM_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesProcessorTypeCategoryImpl <em>Hyades Processor Type Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesProcessorTypeCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesProcessorTypeCategory()
	 * @generated
	 */
	int HYADES_PROCESSOR_TYPE_CATEGORY = 10;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Processor Type Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesMemorySizeCategoryImpl <em>Hyades Memory Size Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesMemorySizeCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesMemorySizeCategory()
	 * @generated
	 */
	int HYADES_MEMORY_SIZE_CATEGORY = 11;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MEMORY_SIZE_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MEMORY_SIZE_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MEMORY_SIZE_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MEMORY_SIZE_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MEMORY_SIZE_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MEMORY_SIZE_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MEMORY_SIZE_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Memory Size Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MEMORY_SIZE_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesProcessorSpeedCategoryImpl <em>Hyades Processor Speed Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesProcessorSpeedCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesProcessorSpeedCategory()
	 * @generated
	 */
	int HYADES_PROCESSOR_SPEED_CATEGORY = 12;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_SPEED_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_SPEED_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_SPEED_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_SPEED_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_SPEED_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_SPEED_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_SPEED_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Processor Speed Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_SPEED_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesProcessorTypeEnumerationImpl <em>Hyades Processor Type Enumeration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesProcessorTypeEnumerationImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION = 13;

	/**
	 * The feature id for the '<em><b>Values</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__VALUES = CFG_PSUDO_ENUMERATION__VALUES;

	/**
	 * The feature id for the '<em><b>Category</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__CATEGORY = CFG_PSUDO_ENUMERATION__CATEGORY;

	/**
	 * The feature id for the '<em><b>PR 1</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_1 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>PR 2</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_2 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>PR 3</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_3 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>PR 4</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_4 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>PR 5</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_5 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>PR 6</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_6 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>PR 7</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_7 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>PR 8</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_8 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>PR 9</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_9 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>PR 10</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_10 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>PR 11</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_11 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>PR 12</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_12 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 11;

	/**
	 * The feature id for the '<em><b>PR 13</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_13 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 12;

	/**
	 * The feature id for the '<em><b>PR 14</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_14 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 13;

	/**
	 * The feature id for the '<em><b>PR 15</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_15 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 14;

	/**
	 * The feature id for the '<em><b>PR 16</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_16 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 15;

	/**
	 * The feature id for the '<em><b>PR 17</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_17 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 16;

	/**
	 * The feature id for the '<em><b>PR 18</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_18 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 17;

	/**
	 * The feature id for the '<em><b>PR 19</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_19 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 18;

	/**
	 * The feature id for the '<em><b>PR 50</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_50 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 19;

	/**
	 * The feature id for the '<em><b>PR 51</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_51 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 20;

	/**
	 * The feature id for the '<em><b>PR 52</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_52 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 21;

	/**
	 * The feature id for the '<em><b>PR 53</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_53 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 22;

	/**
	 * The feature id for the '<em><b>PR 54</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_54 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 23;

	/**
	 * The feature id for the '<em><b>PR 55</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_55 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 24;

	/**
	 * The feature id for the '<em><b>PR 56</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_56 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 25;

	/**
	 * The feature id for the '<em><b>PR 57</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_57 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 26;

	/**
	 * The feature id for the '<em><b>PR 58</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_58 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 27;

	/**
	 * The feature id for the '<em><b>PR 59</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_59 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 28;

	/**
	 * The feature id for the '<em><b>PR 60</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION__PR_60 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 29;

	/**
	 * The number of structural features of the '<em>Hyades Processor Type Enumeration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_TYPE_ENUMERATION_FEATURE_COUNT = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 30;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesBrowserTypeCategoryImpl <em>Hyades Browser Type Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesBrowserTypeCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesBrowserTypeCategory()
	 * @generated
	 */
	int HYADES_BROWSER_TYPE_CATEGORY = 14;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_TYPE_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_TYPE_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_TYPE_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_TYPE_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_TYPE_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_TYPE_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_TYPE_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Browser Type Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_TYPE_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesBrowserVersionCategoryImpl <em>Hyades Browser Version Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesBrowserVersionCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesBrowserVersionCategory()
	 * @generated
	 */
	int HYADES_BROWSER_VERSION_CATEGORY = 15;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_VERSION_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_VERSION_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_VERSION_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_VERSION_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_VERSION_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_VERSION_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_VERSION_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Browser Version Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_VERSION_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesBrowserEnumerationImpl <em>Hyades Browser Enumeration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesBrowserEnumerationImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesBrowserEnumeration()
	 * @generated
	 */
	int HYADES_BROWSER_ENUMERATION = 16;

	/**
	 * The feature id for the '<em><b>Values</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_ENUMERATION__VALUES = CFG_PSUDO_ENUMERATION__VALUES;

	/**
	 * The feature id for the '<em><b>Category</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_ENUMERATION__CATEGORY = CFG_PSUDO_ENUMERATION__CATEGORY;

	/**
	 * The feature id for the '<em><b>WB 1</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_ENUMERATION__WB_1 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>WB 2</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_ENUMERATION__WB_2 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>WB 3</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_ENUMERATION__WB_3 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>WB 4</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_ENUMERATION__WB_4 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>WB 5</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_ENUMERATION__WB_5 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>WB 6</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_ENUMERATION__WB_6 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>WB 7</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_ENUMERATION__WB_7 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the '<em>Hyades Browser Enumeration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_BROWSER_ENUMERATION_FEATURE_COUNT = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 7;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesProcessorNumberCategoryImpl <em>Hyades Processor Number Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesProcessorNumberCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesProcessorNumberCategory()
	 * @generated
	 */
	int HYADES_PROCESSOR_NUMBER_CATEGORY = 17;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_NUMBER_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_NUMBER_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_NUMBER_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_NUMBER_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_NUMBER_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_NUMBER_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_NUMBER_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Processor Number Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PROCESSOR_NUMBER_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayColorDepthCategoryImpl <em>Hyades Display Color Depth Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayColorDepthCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesDisplayColorDepthCategory()
	 * @generated
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_CATEGORY = 18;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Display Color Depth Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayColorDepthEnumerationImpl <em>Hyades Display Color Depth Enumeration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayColorDepthEnumerationImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesDisplayColorDepthEnumeration()
	 * @generated
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION = 19;

	/**
	 * The feature id for the '<em><b>Values</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__VALUES = CFG_PSUDO_ENUMERATION__VALUES;

	/**
	 * The feature id for the '<em><b>Category</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__CATEGORY = CFG_PSUDO_ENUMERATION__CATEGORY;

	/**
	 * The feature id for the '<em><b>DCD 1</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_1 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>DCD 2</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_2 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>DCD 3</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_3 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>DCD 4</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_4 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>DCD 5</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_5 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>DCD 6</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_6 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>DCD 7</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_7 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>DCD 8</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_8 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 7;

	/**
	 * The number of structural features of the '<em>Hyades Display Color Depth Enumeration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION_FEATURE_COUNT = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 8;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayHeightCategoryImpl <em>Hyades Display Height Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayHeightCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesDisplayHeightCategory()
	 * @generated
	 */
	int HYADES_DISPLAY_HEIGHT_CATEGORY = 20;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_HEIGHT_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_HEIGHT_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_HEIGHT_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_HEIGHT_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_HEIGHT_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_HEIGHT_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_HEIGHT_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Display Height Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_HEIGHT_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayWidthCategoryImpl <em>Hyades Display Width Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayWidthCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesDisplayWidthCategory()
	 * @generated
	 */
	int HYADES_DISPLAY_WIDTH_CATEGORY = 21;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_WIDTH_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_WIDTH_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_WIDTH_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_WIDTH_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_WIDTH_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_WIDTH_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_WIDTH_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Display Width Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_WIDTH_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayHeightEnumerationImpl <em>Hyades Display Height Enumeration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayHeightEnumerationImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesDisplayHeightEnumeration()
	 * @generated
	 */
	int HYADES_DISPLAY_HEIGHT_ENUMERATION = 22;

	/**
	 * The feature id for the '<em><b>Values</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_HEIGHT_ENUMERATION__VALUES = CFG_PSUDO_ENUMERATION__VALUES;

	/**
	 * The feature id for the '<em><b>Category</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_HEIGHT_ENUMERATION__CATEGORY = CFG_PSUDO_ENUMERATION__CATEGORY;

	/**
	 * The feature id for the '<em><b>DH 1</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_HEIGHT_ENUMERATION__DH_1 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>DH 2</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_HEIGHT_ENUMERATION__DH_2 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>DH 3</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_HEIGHT_ENUMERATION__DH_3 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>DH 4</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_HEIGHT_ENUMERATION__DH_4 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>DH 5</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_HEIGHT_ENUMERATION__DH_5 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>DH 6</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_HEIGHT_ENUMERATION__DH_6 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>DH 7</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_HEIGHT_ENUMERATION__DH_7 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>DH 8</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_HEIGHT_ENUMERATION__DH_8 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 7;

	/**
	 * The number of structural features of the '<em>Hyades Display Height Enumeration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_HEIGHT_ENUMERATION_FEATURE_COUNT = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 8;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayWidthEnumerationImpl <em>Hyades Display Width Enumeration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayWidthEnumerationImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesDisplayWidthEnumeration()
	 * @generated
	 */
	int HYADES_DISPLAY_WIDTH_ENUMERATION = 23;

	/**
	 * The feature id for the '<em><b>Values</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_WIDTH_ENUMERATION__VALUES = CFG_PSUDO_ENUMERATION__VALUES;

	/**
	 * The feature id for the '<em><b>Category</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_WIDTH_ENUMERATION__CATEGORY = CFG_PSUDO_ENUMERATION__CATEGORY;

	/**
	 * The feature id for the '<em><b>DW 1</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_WIDTH_ENUMERATION__DW_1 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>DW 2</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_WIDTH_ENUMERATION__DW_2 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>DW 3</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_WIDTH_ENUMERATION__DW_3 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>DW 4</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_WIDTH_ENUMERATION__DW_4 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>DW 5</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_WIDTH_ENUMERATION__DW_5 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>DW 6</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_WIDTH_ENUMERATION__DW_6 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>DW 7</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_WIDTH_ENUMERATION__DW_7 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>DW 8</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_WIDTH_ENUMERATION__DW_8 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 7;

	/**
	 * The number of structural features of the '<em>Hyades Display Width Enumeration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_WIDTH_ENUMERATION_FEATURE_COUNT = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 8;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayNumberCategoryImpl <em>Hyades Display Number Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayNumberCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesDisplayNumberCategory()
	 * @generated
	 */
	int HYADES_DISPLAY_NUMBER_CATEGORY = 24;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_NUMBER_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_NUMBER_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_NUMBER_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_NUMBER_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_NUMBER_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_NUMBER_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_NUMBER_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Display Number Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DISPLAY_NUMBER_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDatabaseCategoryImpl <em>Hyades Database Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesDatabaseCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesDatabaseCategory()
	 * @generated
	 */
	int HYADES_DATABASE_CATEGORY = 25;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Database Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDatabaseVersionCategoryImpl <em>Hyades Database Version Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesDatabaseVersionCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesDatabaseVersionCategory()
	 * @generated
	 */
	int HYADES_DATABASE_VERSION_CATEGORY = 26;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_VERSION_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_VERSION_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_VERSION_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_VERSION_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_VERSION_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_VERSION_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_VERSION_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Database Version Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_VERSION_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDatabaseEnumerationImpl <em>Hyades Database Enumeration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesDatabaseEnumerationImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesDatabaseEnumeration()
	 * @generated
	 */
	int HYADES_DATABASE_ENUMERATION = 27;

	/**
	 * The feature id for the '<em><b>Values</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_ENUMERATION__VALUES = CFG_PSUDO_ENUMERATION__VALUES;

	/**
	 * The feature id for the '<em><b>Category</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_ENUMERATION__CATEGORY = CFG_PSUDO_ENUMERATION__CATEGORY;

	/**
	 * The feature id for the '<em><b>DB 1</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_ENUMERATION__DB_1 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>DB 2</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_ENUMERATION__DB_2 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>DB 3</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_ENUMERATION__DB_3 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>DB 4</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_ENUMERATION__DB_4 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Hyades Database Enumeration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_DATABASE_ENUMERATION_FEATURE_COUNT = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGMachineInstanceImpl <em>CFG Machine Instance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.CFGMachineInstanceImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGMachineInstance()
	 * @generated
	 */
	int CFG_MACHINE_INSTANCE = 28;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_INSTANCE__ID = CommonPackage.CMN_NODE_INSTANCE__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_INSTANCE__DESCRIPTION = CommonPackage.CMN_NODE_INSTANCE__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_INSTANCE__NAME = CommonPackage.CMN_NODE_INSTANCE__NAME;

	/**
	 * The feature id for the '<em><b>Property Groups</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_INSTANCE__PROPERTY_GROUPS = CommonPackage.CMN_NODE_INSTANCE__PROPERTY_GROUPS;

	/**
	 * The feature id for the '<em><b>Deployment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_INSTANCE__DEPLOYMENT = CommonPackage.CMN_NODE_INSTANCE__DEPLOYMENT;

	/**
	 * The feature id for the '<em><b>Timezone</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_INSTANCE__TIMEZONE = CommonPackage.CMN_NODE_INSTANCE__TIMEZONE;

	/**
	 * The feature id for the '<em><b>Sub Locations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_INSTANCE__SUB_LOCATIONS = CommonPackage.CMN_NODE_INSTANCE__SUB_LOCATIONS;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_INSTANCE__PARENT = CommonPackage.CMN_NODE_INSTANCE__PARENT;

	/**
	 * The feature id for the '<em><b>Ref Sub Locations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_INSTANCE__REF_SUB_LOCATIONS = CommonPackage.CMN_NODE_INSTANCE__REF_SUB_LOCATIONS;

	/**
	 * The feature id for the '<em><b>Hostname</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_INSTANCE__HOSTNAME = CommonPackage.CMN_NODE_INSTANCE__HOSTNAME;

	/**
	 * The number of structural features of the '<em>CFG Machine Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_INSTANCE_FEATURE_COUNT = CommonPackage.CMN_NODE_INSTANCE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGMachineConstraintImpl <em>CFG Machine Constraint</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.CFGMachineConstraintImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGMachineConstraint()
	 * @generated
	 */
	int CFG_MACHINE_CONSTRAINT = 29;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_CONSTRAINT__ID = CommonPackage.CMN_NODE_TYPE__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_CONSTRAINT__DESCRIPTION = CommonPackage.CMN_NODE_TYPE__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_CONSTRAINT__NAME = CommonPackage.CMN_NODE_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Property Groups</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_CONSTRAINT__PROPERTY_GROUPS = CommonPackage.CMN_NODE_TYPE__PROPERTY_GROUPS;

	/**
	 * The feature id for the '<em><b>Deployment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_CONSTRAINT__DEPLOYMENT = CommonPackage.CMN_NODE_TYPE__DEPLOYMENT;

	/**
	 * The feature id for the '<em><b>Timezone</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_CONSTRAINT__TIMEZONE = CommonPackage.CMN_NODE_TYPE__TIMEZONE;

	/**
	 * The feature id for the '<em><b>Sub Locations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_CONSTRAINT__SUB_LOCATIONS = CommonPackage.CMN_NODE_TYPE__SUB_LOCATIONS;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_CONSTRAINT__PARENT = CommonPackage.CMN_NODE_TYPE__PARENT;

	/**
	 * The feature id for the '<em><b>Ref Sub Locations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_CONSTRAINT__REF_SUB_LOCATIONS = CommonPackage.CMN_NODE_TYPE__REF_SUB_LOCATIONS;

	/**
	 * The feature id for the '<em><b>Hostname</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_CONSTRAINT__HOSTNAME = CommonPackage.CMN_NODE_TYPE__HOSTNAME;

	/**
	 * The number of structural features of the '<em>CFG Machine Constraint</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_CONSTRAINT_FEATURE_COUNT = CommonPackage.CMN_NODE_TYPE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesHostnameCategoryImpl <em>Hyades Hostname Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesHostnameCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesHostnameCategory()
	 * @generated
	 */
	int HYADES_HOSTNAME_CATEGORY = 31;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_HOSTNAME_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_HOSTNAME_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_HOSTNAME_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_HOSTNAME_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_HOSTNAME_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_HOSTNAME_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_HOSTNAME_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Hostname Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_HOSTNAME_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesWindowsDomainCategoryImpl <em>Hyades Windows Domain Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesWindowsDomainCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesWindowsDomainCategory()
	 * @generated
	 */
	int HYADES_WINDOWS_DOMAIN_CATEGORY = 32;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_WINDOWS_DOMAIN_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_WINDOWS_DOMAIN_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_WINDOWS_DOMAIN_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_WINDOWS_DOMAIN_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_WINDOWS_DOMAIN_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_WINDOWS_DOMAIN_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_WINDOWS_DOMAIN_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Windows Domain Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_WINDOWS_DOMAIN_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesUsernameCategoryImpl <em>Hyades Username Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesUsernameCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesUsernameCategory()
	 * @generated
	 */
	int HYADES_USERNAME_CATEGORY = 33;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_USERNAME_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_USERNAME_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_USERNAME_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_USERNAME_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_USERNAME_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_USERNAME_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_USERNAME_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Username Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_USERNAME_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesServicePackCategoryImpl <em>Hyades Service Pack Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesServicePackCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesServicePackCategory()
	 * @generated
	 */
	int HYADES_SERVICE_PACK_CATEGORY = 34;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Service Pack Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesMajorVersionCategoryImpl <em>Hyades Major Version Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesMajorVersionCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesMajorVersionCategory()
	 * @generated
	 */
	int HYADES_MAJOR_VERSION_CATEGORY = 35;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MAJOR_VERSION_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MAJOR_VERSION_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MAJOR_VERSION_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MAJOR_VERSION_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MAJOR_VERSION_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MAJOR_VERSION_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MAJOR_VERSION_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Major Version Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MAJOR_VERSION_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesMinorVersionCategoryImpl <em>Hyades Minor Version Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesMinorVersionCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesMinorVersionCategory()
	 * @generated
	 */
	int HYADES_MINOR_VERSION_CATEGORY = 36;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MINOR_VERSION_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MINOR_VERSION_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MINOR_VERSION_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MINOR_VERSION_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MINOR_VERSION_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MINOR_VERSION_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MINOR_VERSION_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Minor Version Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_MINOR_VERSION_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesServicePackEnumerationImpl <em>Hyades Service Pack Enumeration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesServicePackEnumerationImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesServicePackEnumeration()
	 * @generated
	 */
	int HYADES_SERVICE_PACK_ENUMERATION = 37;

	/**
	 * The feature id for the '<em><b>Values</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__VALUES = CFG_PSUDO_ENUMERATION__VALUES;

	/**
	 * The feature id for the '<em><b>Category</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__CATEGORY = CFG_PSUDO_ENUMERATION__CATEGORY;

	/**
	 * The feature id for the '<em><b>SP 1</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_1 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>SP 2</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_2 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>SP 3</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_3 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>SP 4</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_4 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>SP 5</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_5 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>SP 6</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_6 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>SP 7</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_7 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>SP 8</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_8 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>SP 9</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_9 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>SP 100</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_100 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>SP 101</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_101 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>SP 200</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_200 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 11;

	/**
	 * The feature id for the '<em><b>SP 201</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_201 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 12;

	/**
	 * The feature id for the '<em><b>SP 300</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_300 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 13;

	/**
	 * The feature id for the '<em><b>SP 301</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_301 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 14;

	/**
	 * The feature id for the '<em><b>SP 400</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_400 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 15;

	/**
	 * The feature id for the '<em><b>SP 401</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_401 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 16;

	/**
	 * The feature id for the '<em><b>SP 500</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_500 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 17;

	/**
	 * The feature id for the '<em><b>SP 501</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_501 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 18;

	/**
	 * The feature id for the '<em><b>SP 600</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_600 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 19;

	/**
	 * The feature id for the '<em><b>SP 601</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_601 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 20;

	/**
	 * The feature id for the '<em><b>SP 700</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_700 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 21;

	/**
	 * The feature id for the '<em><b>SP 701</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_701 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 22;

	/**
	 * The feature id for the '<em><b>SP 800</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_800 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 23;

	/**
	 * The feature id for the '<em><b>SP 801</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_801 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 24;

	/**
	 * The feature id for the '<em><b>SP 900</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_900 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 25;

	/**
	 * The feature id for the '<em><b>SP 901</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION__SP_901 = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 26;

	/**
	 * The number of structural features of the '<em>Hyades Service Pack Enumeration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_SERVICE_PACK_ENUMERATION_FEATURE_COUNT = CFG_PSUDO_ENUMERATION_FEATURE_COUNT + 27;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGArtifactLocationPairImpl <em>CFG Artifact Location Pair</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.CFGArtifactLocationPairImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGArtifactLocationPair()
	 * @generated
	 */
	int CFG_ARTIFACT_LOCATION_PAIR = 38;

	/**
	 * The feature id for the '<em><b>Location</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_ARTIFACT_LOCATION_PAIR__LOCATION = 0;

	/**
	 * The feature id for the '<em><b>Artifact</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_ARTIFACT_LOCATION_PAIR__ARTIFACT = 1;

	/**
	 * The number of structural features of the '<em>CFG Artifact Location Pair</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_ARTIFACT_LOCATION_PAIR_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGMachineImpl <em>CFG Machine</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.CFGMachineImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGMachine()
	 * @generated
	 */
	int CFG_MACHINE = 39;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE__ID = CFG_LOCATION__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE__DESCRIPTION = CFG_LOCATION__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE__NAME = CFG_LOCATION__NAME;

	/**
	 * The feature id for the '<em><b>Property Groups</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE__PROPERTY_GROUPS = CFG_LOCATION__PROPERTY_GROUPS;

	/**
	 * The feature id for the '<em><b>Deployment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE__DEPLOYMENT = CFG_LOCATION__DEPLOYMENT;

	/**
	 * The feature id for the '<em><b>Timezone</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE__TIMEZONE = CFG_LOCATION__TIMEZONE;

	/**
	 * The feature id for the '<em><b>Sub Locations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE__SUB_LOCATIONS = CFG_LOCATION__SUB_LOCATIONS;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE__PARENT = CFG_LOCATION__PARENT;

	/**
	 * The feature id for the '<em><b>Ref Sub Locations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE__REF_SUB_LOCATIONS = CFG_LOCATION__REF_SUB_LOCATIONS;

	/**
	 * The feature id for the '<em><b>Host Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE__HOST_NAME = CFG_LOCATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>CFG Machine</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_MACHINE_FEATURE_COUNT = CFG_LOCATION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesPasswordCategoryImpl <em>Hyades Password Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesPasswordCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesPasswordCategory()
	 * @generated
	 */
	int HYADES_PASSWORD_CATEGORY = 41;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PASSWORD_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PASSWORD_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PASSWORD_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PASSWORD_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PASSWORD_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PASSWORD_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PASSWORD_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Password Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_PASSWORD_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesClasspathCategoryImpl <em>Hyades Classpath Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesClasspathCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesClasspathCategory()
	 * @generated
	 */
	int HYADES_CLASSPATH_CATEGORY = 42;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_CLASSPATH_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_CLASSPATH_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_CLASSPATH_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_CLASSPATH_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_CLASSPATH_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_CLASSPATH_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_CLASSPATH_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Classpath Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_CLASSPATH_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesRootDirectroyCategoryImpl <em>Hyades Root Directroy Category</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesRootDirectroyCategoryImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesRootDirectroyCategory()
	 * @generated
	 */
	int HYADES_ROOT_DIRECTROY_CATEGORY = 43;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_ROOT_DIRECTROY_CATEGORY__ID = CFG_CATEGORY__ID;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_ROOT_DIRECTROY_CATEGORY__DESCRIPTION = CFG_CATEGORY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_ROOT_DIRECTROY_CATEGORY__NAME = CFG_CATEGORY__NAME;

	/**
	 * The feature id for the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_ROOT_DIRECTROY_CATEGORY__DISPLAY_NAME = CFG_CATEGORY__DISPLAY_NAME;

	/**
	 * The feature id for the '<em><b>Selection Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_ROOT_DIRECTROY_CATEGORY__SELECTION_MODE = CFG_CATEGORY__SELECTION_MODE;

	/**
	 * The feature id for the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_ROOT_DIRECTROY_CATEGORY__SELECTION_AMOUNT = CFG_CATEGORY__SELECTION_AMOUNT;

	/**
	 * The feature id for the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_ROOT_DIRECTROY_CATEGORY__SELECTION_MULTIPLICITY = CFG_CATEGORY__SELECTION_MULTIPLICITY;

	/**
	 * The number of structural features of the '<em>Hyades Root Directroy Category</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYADES_ROOT_DIRECTROY_CATEGORY_FEATURE_COUNT = CFG_CATEGORY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.CFGCategorySelectionMode <em>CFG Category Selection Mode</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.CFGCategorySelectionMode
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGCategorySelectionMode()
	 * @generated
	 */
	int CFG_CATEGORY_SELECTION_MODE = 44;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.CFGCategorySelectionAmount <em>CFG Category Selection Amount</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.CFGCategorySelectionAmount
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGCategorySelectionAmount()
	 * @generated
	 */
	int CFG_CATEGORY_SELECTION_AMOUNT = 45;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.CFGCategorySelectionMultiplicity <em>CFG Category Selection Multiplicity</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.CFGCategorySelectionMultiplicity
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGCategorySelectionMultiplicity()
	 * @generated
	 */
	int CFG_CATEGORY_SELECTION_MULTIPLICITY = 46;


	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.CFGLocation <em>CFG Location</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CFG Location</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGLocation
	 * @generated
	 */
	EClass getCFGLocation();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.hyades.models.common.configuration.CFGLocation#getDeployment <em>Deployment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Deployment</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGLocation#getDeployment()
	 * @see #getCFGLocation()
	 * @generated
	 */
	EReference getCFGLocation_Deployment();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.hyades.models.common.configuration.CFGLocation#getTimezone <em>Timezone</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Timezone</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGLocation#getTimezone()
	 * @see #getCFGLocation()
	 * @generated
	 */
	EReference getCFGLocation_Timezone();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.models.common.configuration.CFGLocation#getSubLocations <em>Sub Locations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sub Locations</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGLocation#getSubLocations()
	 * @see #getCFGLocation()
	 * @generated
	 */
	EReference getCFGLocation_SubLocations();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.hyades.models.common.configuration.CFGLocation#getParent <em>Parent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGLocation#getParent()
	 * @see #getCFGLocation()
	 * @generated
	 */
	EReference getCFGLocation_Parent();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.hyades.models.common.configuration.CFGLocation#getRefSubLocations <em>Ref Sub Locations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Ref Sub Locations</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGLocation#getRefSubLocations()
	 * @see #getCFGLocation()
	 * @generated
	 */
	EReference getCFGLocation_RefSubLocations();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.CFGClass <em>CFG Class</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CFG Class</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGClass
	 * @generated
	 */
	EClass getCFGClass();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.models.common.configuration.CFGClass#getOperations <em>Operations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Operations</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGClass#getOperations()
	 * @see #getCFGClass()
	 * @generated
	 */
	EReference getCFGClass_Operations();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.models.common.configuration.CFGClass#getInstances <em>Instances</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Instances</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGClass#getInstances()
	 * @see #getCFGClass()
	 * @generated
	 */
	EReference getCFGClass_Instances();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.hyades.models.common.configuration.CFGClass#getInstantiations <em>Instantiations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Instantiations</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGClass#getInstantiations()
	 * @see #getCFGClass()
	 * @generated
	 */
	EReference getCFGClass_Instantiations();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.CFGOperation <em>CFG Operation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CFG Operation</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGOperation
	 * @generated
	 */
	EClass getCFGOperation();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.hyades.models.common.configuration.CFGOperation#getOwningClass <em>Owning Class</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Owning Class</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGOperation#getOwningClass()
	 * @see #getCFGOperation()
	 * @generated
	 */
	EReference getCFGOperation_OwningClass();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.CFGArtifact <em>CFG Artifact</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CFG Artifact</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGArtifact
	 * @generated
	 */
	EClass getCFGArtifact();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.hyades.models.common.configuration.CFGArtifact#getDeployableInstances <em>Deployable Instances</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Deployable Instances</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGArtifact#getDeployableInstances()
	 * @see #getCFGArtifact()
	 * @generated
	 */
	EReference getCFGArtifact_DeployableInstances();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.CFGInstance <em>CFG Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CFG Instance</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGInstance
	 * @generated
	 */
	EClass getCFGInstance();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getMaxCount <em>Max Count</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max Count</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGInstance#getMaxCount()
	 * @see #getCFGInstance()
	 * @generated
	 */
	EAttribute getCFGInstance_MaxCount();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getInitialValue <em>Initial Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Initial Value</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGInstance#getInitialValue()
	 * @see #getCFGInstance()
	 * @generated
	 */
	EAttribute getCFGInstance_InitialValue();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getLifeline <em>Lifeline</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Lifeline</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGInstance#getLifeline()
	 * @see #getCFGInstance()
	 * @generated
	 */
	EReference getCFGInstance_Lifeline();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getTestCase <em>Test Case</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Test Case</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGInstance#getTestCase()
	 * @see #getCFGInstance()
	 * @generated
	 */
	EReference getCFGInstance_TestCase();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getClassOwner <em>Class Owner</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Class Owner</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGInstance#getClassOwner()
	 * @see #getCFGInstance()
	 * @generated
	 */
	EReference getCFGInstance_ClassOwner();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getClassType <em>Class Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Class Type</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGInstance#getClassType()
	 * @see #getCFGInstance()
	 * @generated
	 */
	EReference getCFGInstance_ClassType();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.CFGComparableProperty <em>CFG Comparable Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CFG Comparable Property</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGComparableProperty
	 * @generated
	 */
	EClass getCFGComparableProperty();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.models.common.configuration.CFGComparableProperty#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Type</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGComparableProperty#getType()
	 * @see #getCFGComparableProperty()
	 * @generated
	 */
	EReference getCFGComparableProperty_Type();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.models.common.configuration.CFGComparableProperty#getSubPropertyGroups <em>Sub Property Groups</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sub Property Groups</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGComparableProperty#getSubPropertyGroups()
	 * @see #getCFGComparableProperty()
	 * @generated
	 */
	EReference getCFGComparableProperty_SubPropertyGroups();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGComparableProperty#getOperator <em>Operator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Operator</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGComparableProperty#getOperator()
	 * @see #getCFGComparableProperty()
	 * @generated
	 */
	EAttribute getCFGComparableProperty_Operator();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.CFGPropertyGroup <em>CFG Property Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CFG Property Group</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGPropertyGroup
	 * @generated
	 */
	EClass getCFGPropertyGroup();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGPropertyGroup#getPropertyGroupID <em>Property Group ID</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Property Group ID</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGPropertyGroup#getPropertyGroupID()
	 * @see #getCFGPropertyGroup()
	 * @generated
	 */
	EAttribute getCFGPropertyGroup_PropertyGroupID();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.models.common.configuration.CFGPropertyGroup#getProperties <em>Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Properties</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGPropertyGroup#getProperties()
	 * @see #getCFGPropertyGroup()
	 * @generated
	 */
	EReference getCFGPropertyGroup_Properties();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.hyades.models.common.configuration.CFGPropertyGroup#getDefiningProperty <em>Defining Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Defining Property</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGPropertyGroup#getDefiningProperty()
	 * @see #getCFGPropertyGroup()
	 * @generated
	 */
	EReference getCFGPropertyGroup_DefiningProperty();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.hyades.models.common.configuration.CFGPropertyGroup#getConfigurableObject <em>Configurable Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Configurable Object</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGPropertyGroup#getConfigurableObject()
	 * @see #getCFGPropertyGroup()
	 * @generated
	 */
	EReference getCFGPropertyGroup_ConfigurableObject();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.CFGCategory <em>CFG Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CFG Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGCategory
	 * @generated
	 */
	EClass getCFGCategory();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGCategory#getDisplayName <em>Display Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Display Name</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGCategory#getDisplayName()
	 * @see #getCFGCategory()
	 * @generated
	 */
	EAttribute getCFGCategory_DisplayName();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGCategory#getSelectionMode <em>Selection Mode</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Selection Mode</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGCategory#getSelectionMode()
	 * @see #getCFGCategory()
	 * @generated
	 */
	EAttribute getCFGCategory_SelectionMode();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGCategory#getSelectionAmount <em>Selection Amount</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Selection Amount</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGCategory#getSelectionAmount()
	 * @see #getCFGCategory()
	 * @generated
	 */
	EAttribute getCFGCategory_SelectionAmount();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGCategory#getSelectionMultiplicity <em>Selection Multiplicity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Selection Multiplicity</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGCategory#getSelectionMultiplicity()
	 * @see #getCFGCategory()
	 * @generated
	 */
	EAttribute getCFGCategory_SelectionMultiplicity();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration <em>Hyades Operating System Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Operating System Enumeration</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration
	 * @generated
	 */
	EClass getHyadesOperatingSystemEnumeration();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_1 <em>OS 1</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 1</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_1()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_1();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_2 <em>OS 2</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 2</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_2()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_2();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_3 <em>OS 3</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 3</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_3()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_3();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_4 <em>OS 4</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 4</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_4()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_4();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_5 <em>OS 5</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 5</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_5()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_5();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_6 <em>OS 6</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 6</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_6()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_6();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_7 <em>OS 7</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 7</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_7()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_7();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_8 <em>OS 8</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 8</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_8()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_8();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_9 <em>OS 9</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 9</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_9()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_9();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_10 <em>OS 10</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 10</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_10()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_10();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_11 <em>OS 11</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 11</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_11()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_11();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_12 <em>OS 12</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 12</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_12()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_12();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_13 <em>OS 13</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 13</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_13()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_13();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_14 <em>OS 14</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 14</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_14()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_14();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_50 <em>OS 50</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 50</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_50()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_50();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_51 <em>OS 51</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 51</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_51()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_51();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_52 <em>OS 52</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 52</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_52()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_52();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_53 <em>OS 53</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 53</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_53()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_53();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_54 <em>OS 54</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 54</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_54()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_54();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_55 <em>OS 55</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 55</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_55()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_55();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_60 <em>OS 60</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 60</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_60()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_60();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_61 <em>OS 61</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 61</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_61()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_61();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_62 <em>OS 62</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 62</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_62()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_62();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_63 <em>OS 63</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 63</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_63()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_63();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_64 <em>OS 64</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 64</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_64()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_64();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_65 <em>OS 65</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 65</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_65()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_65();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_70 <em>OS 70</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 70</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_70()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_70();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_71 <em>OS 71</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 71</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_71()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_71();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_80 <em>OS 80</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 80</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_80()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_80();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_81 <em>OS 81</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 81</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_81()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_81();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_82 <em>OS 82</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 82</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_82()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_82();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_90 <em>OS 90</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 90</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_90()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_90();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_100 <em>OS 100</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>OS 100</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration#getOS_100()
	 * @see #getHyadesOperatingSystemEnumeration()
	 * @generated
	 */
	EAttribute getHyadesOperatingSystemEnumeration_OS_100();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemCategory <em>Hyades Operating System Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Operating System Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemCategory
	 * @generated
	 */
	EClass getHyadesOperatingSystemCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeCategory <em>Hyades Processor Type Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Processor Type Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeCategory
	 * @generated
	 */
	EClass getHyadesProcessorTypeCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesMemorySizeCategory <em>Hyades Memory Size Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Memory Size Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesMemorySizeCategory
	 * @generated
	 */
	EClass getHyadesMemorySizeCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorSpeedCategory <em>Hyades Processor Speed Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Processor Speed Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorSpeedCategory
	 * @generated
	 */
	EClass getHyadesProcessorSpeedCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration <em>Hyades Processor Type Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Processor Type Enumeration</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration
	 * @generated
	 */
	EClass getHyadesProcessorTypeEnumeration();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_1 <em>PR 1</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 1</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_1()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_1();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_2 <em>PR 2</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 2</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_2()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_2();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_3 <em>PR 3</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 3</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_3()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_3();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_4 <em>PR 4</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 4</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_4()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_4();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_5 <em>PR 5</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 5</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_5()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_5();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_6 <em>PR 6</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 6</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_6()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_6();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_7 <em>PR 7</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 7</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_7()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_7();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_8 <em>PR 8</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 8</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_8()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_8();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_9 <em>PR 9</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 9</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_9()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_9();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_10 <em>PR 10</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 10</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_10()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_10();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_11 <em>PR 11</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 11</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_11()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_11();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_12 <em>PR 12</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 12</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_12()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_12();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_13 <em>PR 13</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 13</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_13()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_13();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_14 <em>PR 14</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 14</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_14()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_14();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_15 <em>PR 15</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 15</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_15()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_15();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_16 <em>PR 16</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 16</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_16()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_16();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_17 <em>PR 17</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 17</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_17()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_17();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_18 <em>PR 18</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 18</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_18()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_18();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_19 <em>PR 19</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 19</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_19()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_19();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_50 <em>PR 50</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 50</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_50()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_50();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_51 <em>PR 51</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 51</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_51()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_51();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_52 <em>PR 52</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 52</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_52()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_52();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_53 <em>PR 53</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 53</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_53()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_53();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_54 <em>PR 54</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 54</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_54()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_54();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_55 <em>PR 55</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 55</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_55()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_55();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_56 <em>PR 56</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 56</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_56()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_56();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_57 <em>PR 57</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 57</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_57()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_57();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_58 <em>PR 58</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 58</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_58()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_58();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_59 <em>PR 59</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 59</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_59()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_59();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_60 <em>PR 60</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PR 60</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration#getPR_60()
	 * @see #getHyadesProcessorTypeEnumeration()
	 * @generated
	 */
	EAttribute getHyadesProcessorTypeEnumeration_PR_60();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesBrowserTypeCategory <em>Hyades Browser Type Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Browser Type Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesBrowserTypeCategory
	 * @generated
	 */
	EClass getHyadesBrowserTypeCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesBrowserVersionCategory <em>Hyades Browser Version Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Browser Version Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesBrowserVersionCategory
	 * @generated
	 */
	EClass getHyadesBrowserVersionCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesBrowserEnumeration <em>Hyades Browser Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Browser Enumeration</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesBrowserEnumeration
	 * @generated
	 */
	EClass getHyadesBrowserEnumeration();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesBrowserEnumeration#getWB_1 <em>WB 1</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>WB 1</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesBrowserEnumeration#getWB_1()
	 * @see #getHyadesBrowserEnumeration()
	 * @generated
	 */
	EAttribute getHyadesBrowserEnumeration_WB_1();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesBrowserEnumeration#getWB_2 <em>WB 2</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>WB 2</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesBrowserEnumeration#getWB_2()
	 * @see #getHyadesBrowserEnumeration()
	 * @generated
	 */
	EAttribute getHyadesBrowserEnumeration_WB_2();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesBrowserEnumeration#getWB_3 <em>WB 3</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>WB 3</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesBrowserEnumeration#getWB_3()
	 * @see #getHyadesBrowserEnumeration()
	 * @generated
	 */
	EAttribute getHyadesBrowserEnumeration_WB_3();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesBrowserEnumeration#getWB_4 <em>WB 4</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>WB 4</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesBrowserEnumeration#getWB_4()
	 * @see #getHyadesBrowserEnumeration()
	 * @generated
	 */
	EAttribute getHyadesBrowserEnumeration_WB_4();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesBrowserEnumeration#getWB_5 <em>WB 5</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>WB 5</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesBrowserEnumeration#getWB_5()
	 * @see #getHyadesBrowserEnumeration()
	 * @generated
	 */
	EAttribute getHyadesBrowserEnumeration_WB_5();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesBrowserEnumeration#getWB_6 <em>WB 6</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>WB 6</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesBrowserEnumeration#getWB_6()
	 * @see #getHyadesBrowserEnumeration()
	 * @generated
	 */
	EAttribute getHyadesBrowserEnumeration_WB_6();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesBrowserEnumeration#getWB_7 <em>WB 7</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>WB 7</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesBrowserEnumeration#getWB_7()
	 * @see #getHyadesBrowserEnumeration()
	 * @generated
	 */
	EAttribute getHyadesBrowserEnumeration_WB_7();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorNumberCategory <em>Hyades Processor Number Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Processor Number Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorNumberCategory
	 * @generated
	 */
	EClass getHyadesProcessorNumberCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthCategory <em>Hyades Display Color Depth Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Display Color Depth Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthCategory
	 * @generated
	 */
	EClass getHyadesDisplayColorDepthCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration <em>Hyades Display Color Depth Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Display Color Depth Enumeration</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration
	 * @generated
	 */
	EClass getHyadesDisplayColorDepthEnumeration();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration#getDCD_1 <em>DCD 1</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DCD 1</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration#getDCD_1()
	 * @see #getHyadesDisplayColorDepthEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayColorDepthEnumeration_DCD_1();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration#getDCD_2 <em>DCD 2</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DCD 2</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration#getDCD_2()
	 * @see #getHyadesDisplayColorDepthEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayColorDepthEnumeration_DCD_2();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration#getDCD_3 <em>DCD 3</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DCD 3</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration#getDCD_3()
	 * @see #getHyadesDisplayColorDepthEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayColorDepthEnumeration_DCD_3();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration#getDCD_4 <em>DCD 4</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DCD 4</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration#getDCD_4()
	 * @see #getHyadesDisplayColorDepthEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayColorDepthEnumeration_DCD_4();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration#getDCD_5 <em>DCD 5</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DCD 5</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration#getDCD_5()
	 * @see #getHyadesDisplayColorDepthEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayColorDepthEnumeration_DCD_5();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration#getDCD_6 <em>DCD 6</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DCD 6</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration#getDCD_6()
	 * @see #getHyadesDisplayColorDepthEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayColorDepthEnumeration_DCD_6();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration#getDCD_7 <em>DCD 7</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DCD 7</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration#getDCD_7()
	 * @see #getHyadesDisplayColorDepthEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayColorDepthEnumeration_DCD_7();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration#getDCD_8 <em>DCD 8</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DCD 8</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration#getDCD_8()
	 * @see #getHyadesDisplayColorDepthEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayColorDepthEnumeration_DCD_8();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightCategory <em>Hyades Display Height Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Display Height Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightCategory
	 * @generated
	 */
	EClass getHyadesDisplayHeightCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthCategory <em>Hyades Display Width Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Display Width Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthCategory
	 * @generated
	 */
	EClass getHyadesDisplayWidthCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration <em>Hyades Display Height Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Display Height Enumeration</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration
	 * @generated
	 */
	EClass getHyadesDisplayHeightEnumeration();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_1 <em>DH 1</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DH 1</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_1()
	 * @see #getHyadesDisplayHeightEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayHeightEnumeration_DH_1();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_2 <em>DH 2</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DH 2</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_2()
	 * @see #getHyadesDisplayHeightEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayHeightEnumeration_DH_2();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_3 <em>DH 3</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DH 3</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_3()
	 * @see #getHyadesDisplayHeightEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayHeightEnumeration_DH_3();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_4 <em>DH 4</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DH 4</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_4()
	 * @see #getHyadesDisplayHeightEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayHeightEnumeration_DH_4();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_5 <em>DH 5</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DH 5</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_5()
	 * @see #getHyadesDisplayHeightEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayHeightEnumeration_DH_5();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_6 <em>DH 6</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DH 6</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_6()
	 * @see #getHyadesDisplayHeightEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayHeightEnumeration_DH_6();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_7 <em>DH 7</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DH 7</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_7()
	 * @see #getHyadesDisplayHeightEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayHeightEnumeration_DH_7();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_8 <em>DH 8</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DH 8</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_8()
	 * @see #getHyadesDisplayHeightEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayHeightEnumeration_DH_8();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration <em>Hyades Display Width Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Display Width Enumeration</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration
	 * @generated
	 */
	EClass getHyadesDisplayWidthEnumeration();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration#getDW_1 <em>DW 1</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DW 1</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration#getDW_1()
	 * @see #getHyadesDisplayWidthEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayWidthEnumeration_DW_1();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration#getDW_2 <em>DW 2</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DW 2</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration#getDW_2()
	 * @see #getHyadesDisplayWidthEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayWidthEnumeration_DW_2();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration#getDW_3 <em>DW 3</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DW 3</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration#getDW_3()
	 * @see #getHyadesDisplayWidthEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayWidthEnumeration_DW_3();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration#getDW_4 <em>DW 4</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DW 4</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration#getDW_4()
	 * @see #getHyadesDisplayWidthEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayWidthEnumeration_DW_4();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration#getDW_5 <em>DW 5</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DW 5</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration#getDW_5()
	 * @see #getHyadesDisplayWidthEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayWidthEnumeration_DW_5();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration#getDW_6 <em>DW 6</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DW 6</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration#getDW_6()
	 * @see #getHyadesDisplayWidthEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayWidthEnumeration_DW_6();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration#getDW_7 <em>DW 7</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DW 7</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration#getDW_7()
	 * @see #getHyadesDisplayWidthEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayWidthEnumeration_DW_7();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration#getDW_8 <em>DW 8</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DW 8</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration#getDW_8()
	 * @see #getHyadesDisplayWidthEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDisplayWidthEnumeration_DW_8();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayNumberCategory <em>Hyades Display Number Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Display Number Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayNumberCategory
	 * @generated
	 */
	EClass getHyadesDisplayNumberCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesDatabaseCategory <em>Hyades Database Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Database Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDatabaseCategory
	 * @generated
	 */
	EClass getHyadesDatabaseCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesDatabaseVersionCategory <em>Hyades Database Version Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Database Version Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDatabaseVersionCategory
	 * @generated
	 */
	EClass getHyadesDatabaseVersionCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesDatabaseEnumeration <em>Hyades Database Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Database Enumeration</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDatabaseEnumeration
	 * @generated
	 */
	EClass getHyadesDatabaseEnumeration();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDatabaseEnumeration#getDB_1 <em>DB 1</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DB 1</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDatabaseEnumeration#getDB_1()
	 * @see #getHyadesDatabaseEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDatabaseEnumeration_DB_1();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDatabaseEnumeration#getDB_2 <em>DB 2</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DB 2</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDatabaseEnumeration#getDB_2()
	 * @see #getHyadesDatabaseEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDatabaseEnumeration_DB_2();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDatabaseEnumeration#getDB_3 <em>DB 3</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DB 3</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDatabaseEnumeration#getDB_3()
	 * @see #getHyadesDatabaseEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDatabaseEnumeration_DB_3();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesDatabaseEnumeration#getDB_4 <em>DB 4</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>DB 4</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDatabaseEnumeration#getDB_4()
	 * @see #getHyadesDatabaseEnumeration()
	 * @generated
	 */
	EAttribute getHyadesDatabaseEnumeration_DB_4();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.CFGMachineInstance <em>CFG Machine Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CFG Machine Instance</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGMachineInstance
	 * @generated
	 */
	EClass getCFGMachineInstance();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.CFGMachineConstraint <em>CFG Machine Constraint</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CFG Machine Constraint</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGMachineConstraint
	 * @generated
	 */
	EClass getCFGMachineConstraint();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.CFGConfigurableObject <em>CFG Configurable Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CFG Configurable Object</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGConfigurableObject
	 * @generated
	 */
	EClass getCFGConfigurableObject();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.models.common.configuration.CFGConfigurableObject#getPropertyGroups <em>Property Groups</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Property Groups</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGConfigurableObject#getPropertyGroups()
	 * @see #getCFGConfigurableObject()
	 * @generated
	 */
	EReference getCFGConfigurableObject_PropertyGroups();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesHostnameCategory <em>Hyades Hostname Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Hostname Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesHostnameCategory
	 * @generated
	 */
	EClass getHyadesHostnameCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesWindowsDomainCategory <em>Hyades Windows Domain Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Windows Domain Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesWindowsDomainCategory
	 * @generated
	 */
	EClass getHyadesWindowsDomainCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesUsernameCategory <em>Hyades Username Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Username Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesUsernameCategory
	 * @generated
	 */
	EClass getHyadesUsernameCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackCategory <em>Hyades Service Pack Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Service Pack Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackCategory
	 * @generated
	 */
	EClass getHyadesServicePackCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesMajorVersionCategory <em>Hyades Major Version Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Major Version Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesMajorVersionCategory
	 * @generated
	 */
	EClass getHyadesMajorVersionCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesMinorVersionCategory <em>Hyades Minor Version Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Minor Version Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesMinorVersionCategory
	 * @generated
	 */
	EClass getHyadesMinorVersionCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration <em>Hyades Service Pack Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Service Pack Enumeration</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration
	 * @generated
	 */
	EClass getHyadesServicePackEnumeration();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_1 <em>SP 1</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 1</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_1()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_1();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_2 <em>SP 2</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 2</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_2()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_2();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_3 <em>SP 3</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 3</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_3()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_3();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_4 <em>SP 4</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 4</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_4()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_4();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_5 <em>SP 5</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 5</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_5()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_5();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_6 <em>SP 6</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 6</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_6()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_6();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_7 <em>SP 7</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 7</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_7()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_7();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_8 <em>SP 8</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 8</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_8()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_8();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_9 <em>SP 9</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 9</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_9()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_9();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_100 <em>SP 100</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 100</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_100()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_100();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_101 <em>SP 101</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 101</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_101()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_101();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_200 <em>SP 200</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 200</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_200()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_200();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_201 <em>SP 201</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 201</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_201()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_201();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_300 <em>SP 300</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 300</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_300()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_300();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_301 <em>SP 301</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 301</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_301()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_301();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_400 <em>SP 400</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 400</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_400()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_400();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_401 <em>SP 401</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 401</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_401()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_401();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_500 <em>SP 500</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 500</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_500()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_500();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_501 <em>SP 501</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 501</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_501()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_501();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_600 <em>SP 600</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 600</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_600()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_600();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_601 <em>SP 601</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 601</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_601()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_601();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_700 <em>SP 700</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 700</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_700()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_700();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_701 <em>SP 701</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 701</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_701()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_701();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_800 <em>SP 800</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 800</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_800()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_800();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_801 <em>SP 801</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 801</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_801()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_801();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_900 <em>SP 900</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 900</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_900()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_900();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_901 <em>SP 901</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SP 901</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration#getSP_901()
	 * @see #getHyadesServicePackEnumeration()
	 * @generated
	 */
	EAttribute getHyadesServicePackEnumeration_SP_901();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.CFGArtifactLocationPair <em>CFG Artifact Location Pair</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CFG Artifact Location Pair</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGArtifactLocationPair
	 * @generated
	 */
	EClass getCFGArtifactLocationPair();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.hyades.models.common.configuration.CFGArtifactLocationPair#getLocation <em>Location</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Location</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGArtifactLocationPair#getLocation()
	 * @see #getCFGArtifactLocationPair()
	 * @generated
	 */
	EReference getCFGArtifactLocationPair_Location();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.hyades.models.common.configuration.CFGArtifactLocationPair#getArtifact <em>Artifact</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Artifact</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGArtifactLocationPair#getArtifact()
	 * @see #getCFGArtifactLocationPair()
	 * @generated
	 */
	EReference getCFGArtifactLocationPair_Artifact();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.CFGMachine <em>CFG Machine</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CFG Machine</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGMachine
	 * @generated
	 */
	EClass getCFGMachine();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGMachine#getHostName <em>Host Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Host Name</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGMachine#getHostName()
	 * @see #getCFGMachine()
	 * @generated
	 */
	EAttribute getCFGMachine_HostName();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.CFGPsudoEnumeration <em>CFG Psudo Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CFG Psudo Enumeration</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGPsudoEnumeration
	 * @generated
	 */
	EClass getCFGPsudoEnumeration();

	/**
	 * Returns the meta object for the attribute list '{@link org.eclipse.hyades.models.common.configuration.CFGPsudoEnumeration#getValues <em>Values</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Values</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGPsudoEnumeration#getValues()
	 * @see #getCFGPsudoEnumeration()
	 * @generated
	 */
	EAttribute getCFGPsudoEnumeration_Values();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.models.common.configuration.CFGPsudoEnumeration#getCategory <em>Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGPsudoEnumeration#getCategory()
	 * @see #getCFGPsudoEnumeration()
	 * @generated
	 */
	EReference getCFGPsudoEnumeration_Category();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesPasswordCategory <em>Hyades Password Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Password Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesPasswordCategory
	 * @generated
	 */
	EClass getHyadesPasswordCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesClasspathCategory <em>Hyades Classpath Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Classpath Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesClasspathCategory
	 * @generated
	 */
	EClass getHyadesClasspathCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.HyadesRootDirectroyCategory <em>Hyades Root Directroy Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyades Root Directroy Category</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesRootDirectroyCategory
	 * @generated
	 */
	EClass getHyadesRootDirectroyCategory();

	/**
	 * Returns the meta object for enum '{@link org.eclipse.hyades.models.common.configuration.CFGCategorySelectionMode <em>CFG Category Selection Mode</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>CFG Category Selection Mode</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGCategorySelectionMode
	 * @generated
	 */
	EEnum getCFGCategorySelectionMode();

	/**
	 * Returns the meta object for enum '{@link org.eclipse.hyades.models.common.configuration.CFGCategorySelectionAmount <em>CFG Category Selection Amount</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>CFG Category Selection Amount</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGCategorySelectionAmount
	 * @generated
	 */
	EEnum getCFGCategorySelectionAmount();

	/**
	 * Returns the meta object for enum '{@link org.eclipse.hyades.models.common.configuration.CFGCategorySelectionMultiplicity <em>CFG Category Selection Multiplicity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>CFG Category Selection Multiplicity</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGCategorySelectionMultiplicity
	 * @generated
	 */
	EEnum getCFGCategorySelectionMultiplicity();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	Common_ConfigurationFactory getCommon_ConfigurationFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals  {
		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGLocationImpl <em>CFG Location</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.CFGLocationImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGLocation()
		 * @generated
		 */
		EClass CFG_LOCATION = eINSTANCE.getCFGLocation();

		/**
		 * The meta object literal for the '<em><b>Deployment</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_LOCATION__DEPLOYMENT = eINSTANCE.getCFGLocation_Deployment();

		/**
		 * The meta object literal for the '<em><b>Timezone</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_LOCATION__TIMEZONE = eINSTANCE.getCFGLocation_Timezone();

		/**
		 * The meta object literal for the '<em><b>Sub Locations</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_LOCATION__SUB_LOCATIONS = eINSTANCE.getCFGLocation_SubLocations();

		/**
		 * The meta object literal for the '<em><b>Parent</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_LOCATION__PARENT = eINSTANCE.getCFGLocation_Parent();

		/**
		 * The meta object literal for the '<em><b>Ref Sub Locations</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_LOCATION__REF_SUB_LOCATIONS = eINSTANCE.getCFGLocation_RefSubLocations();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGClassImpl <em>CFG Class</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.CFGClassImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGClass()
		 * @generated
		 */
		EClass CFG_CLASS = eINSTANCE.getCFGClass();

		/**
		 * The meta object literal for the '<em><b>Operations</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_CLASS__OPERATIONS = eINSTANCE.getCFGClass_Operations();

		/**
		 * The meta object literal for the '<em><b>Instances</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_CLASS__INSTANCES = eINSTANCE.getCFGClass_Instances();

		/**
		 * The meta object literal for the '<em><b>Instantiations</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_CLASS__INSTANTIATIONS = eINSTANCE.getCFGClass_Instantiations();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGOperationImpl <em>CFG Operation</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.CFGOperationImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGOperation()
		 * @generated
		 */
		EClass CFG_OPERATION = eINSTANCE.getCFGOperation();

		/**
		 * The meta object literal for the '<em><b>Owning Class</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_OPERATION__OWNING_CLASS = eINSTANCE.getCFGOperation_OwningClass();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGArtifactImpl <em>CFG Artifact</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.CFGArtifactImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGArtifact()
		 * @generated
		 */
		EClass CFG_ARTIFACT = eINSTANCE.getCFGArtifact();

		/**
		 * The meta object literal for the '<em><b>Deployable Instances</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_ARTIFACT__DEPLOYABLE_INSTANCES = eINSTANCE.getCFGArtifact_DeployableInstances();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGInstanceImpl <em>CFG Instance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.CFGInstanceImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGInstance()
		 * @generated
		 */
		EClass CFG_INSTANCE = eINSTANCE.getCFGInstance();

		/**
		 * The meta object literal for the '<em><b>Lifeline</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_INSTANCE__LIFELINE = eINSTANCE.getCFGInstance_Lifeline();

		/**
		 * The meta object literal for the '<em><b>Test Case</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_INSTANCE__TEST_CASE = eINSTANCE.getCFGInstance_TestCase();

		/**
		 * The meta object literal for the '<em><b>Max Count</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CFG_INSTANCE__MAX_COUNT = eINSTANCE.getCFGInstance_MaxCount();

		/**
		 * The meta object literal for the '<em><b>Initial Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CFG_INSTANCE__INITIAL_VALUE = eINSTANCE.getCFGInstance_InitialValue();

		/**
		 * The meta object literal for the '<em><b>Class Owner</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_INSTANCE__CLASS_OWNER = eINSTANCE.getCFGInstance_ClassOwner();

		/**
		 * The meta object literal for the '<em><b>Class Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_INSTANCE__CLASS_TYPE = eINSTANCE.getCFGInstance_ClassType();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGComparablePropertyImpl <em>CFG Comparable Property</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.CFGComparablePropertyImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGComparableProperty()
		 * @generated
		 */
		EClass CFG_COMPARABLE_PROPERTY = eINSTANCE.getCFGComparableProperty();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_COMPARABLE_PROPERTY__TYPE = eINSTANCE.getCFGComparableProperty_Type();

		/**
		 * The meta object literal for the '<em><b>Operator</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CFG_COMPARABLE_PROPERTY__OPERATOR = eINSTANCE.getCFGComparableProperty_Operator();

		/**
		 * The meta object literal for the '<em><b>Sub Property Groups</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_COMPARABLE_PROPERTY__SUB_PROPERTY_GROUPS = eINSTANCE.getCFGComparableProperty_SubPropertyGroups();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGPropertyGroupImpl <em>CFG Property Group</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.CFGPropertyGroupImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGPropertyGroup()
		 * @generated
		 */
		EClass CFG_PROPERTY_GROUP = eINSTANCE.getCFGPropertyGroup();

		/**
		 * The meta object literal for the '<em><b>Property Group ID</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CFG_PROPERTY_GROUP__PROPERTY_GROUP_ID = eINSTANCE.getCFGPropertyGroup_PropertyGroupID();

		/**
		 * The meta object literal for the '<em><b>Properties</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_PROPERTY_GROUP__PROPERTIES = eINSTANCE.getCFGPropertyGroup_Properties();

		/**
		 * The meta object literal for the '<em><b>Defining Property</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_PROPERTY_GROUP__DEFINING_PROPERTY = eINSTANCE.getCFGPropertyGroup_DefiningProperty();

		/**
		 * The meta object literal for the '<em><b>Configurable Object</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_PROPERTY_GROUP__CONFIGURABLE_OBJECT = eINSTANCE.getCFGPropertyGroup_ConfigurableObject();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGCategoryImpl <em>CFG Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.CFGCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGCategory()
		 * @generated
		 */
		EClass CFG_CATEGORY = eINSTANCE.getCFGCategory();

		/**
		 * The meta object literal for the '<em><b>Display Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CFG_CATEGORY__DISPLAY_NAME = eINSTANCE.getCFGCategory_DisplayName();

		/**
		 * The meta object literal for the '<em><b>Selection Mode</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CFG_CATEGORY__SELECTION_MODE = eINSTANCE.getCFGCategory_SelectionMode();

		/**
		 * The meta object literal for the '<em><b>Selection Amount</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CFG_CATEGORY__SELECTION_AMOUNT = eINSTANCE.getCFGCategory_SelectionAmount();

		/**
		 * The meta object literal for the '<em><b>Selection Multiplicity</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CFG_CATEGORY__SELECTION_MULTIPLICITY = eINSTANCE.getCFGCategory_SelectionMultiplicity();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesOperatingSystemEnumerationImpl <em>Hyades Operating System Enumeration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesOperatingSystemEnumerationImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesOperatingSystemEnumeration()
		 * @generated
		 */
		EClass HYADES_OPERATING_SYSTEM_ENUMERATION = eINSTANCE.getHyadesOperatingSystemEnumeration();

		/**
		 * The meta object literal for the '<em><b>OS 1</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_1 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_1();

		/**
		 * The meta object literal for the '<em><b>OS 2</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_2 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_2();

		/**
		 * The meta object literal for the '<em><b>OS 3</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_3 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_3();

		/**
		 * The meta object literal for the '<em><b>OS 4</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_4 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_4();

		/**
		 * The meta object literal for the '<em><b>OS 5</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_5 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_5();

		/**
		 * The meta object literal for the '<em><b>OS 6</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_6 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_6();

		/**
		 * The meta object literal for the '<em><b>OS 7</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_7 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_7();

		/**
		 * The meta object literal for the '<em><b>OS 8</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_8 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_8();

		/**
		 * The meta object literal for the '<em><b>OS 9</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_9 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_9();

		/**
		 * The meta object literal for the '<em><b>OS 10</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_10 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_10();

		/**
		 * The meta object literal for the '<em><b>OS 11</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_11 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_11();

		/**
		 * The meta object literal for the '<em><b>OS 12</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_12 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_12();

		/**
		 * The meta object literal for the '<em><b>OS 13</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_13 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_13();

		/**
		 * The meta object literal for the '<em><b>OS 14</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_14 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_14();

		/**
		 * The meta object literal for the '<em><b>OS 50</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_50 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_50();

		/**
		 * The meta object literal for the '<em><b>OS 51</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_51 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_51();

		/**
		 * The meta object literal for the '<em><b>OS 52</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_52 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_52();

		/**
		 * The meta object literal for the '<em><b>OS 53</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_53 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_53();

		/**
		 * The meta object literal for the '<em><b>OS 54</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_54 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_54();

		/**
		 * The meta object literal for the '<em><b>OS 55</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_55 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_55();

		/**
		 * The meta object literal for the '<em><b>OS 60</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_60 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_60();

		/**
		 * The meta object literal for the '<em><b>OS 61</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_61 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_61();

		/**
		 * The meta object literal for the '<em><b>OS 62</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_62 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_62();

		/**
		 * The meta object literal for the '<em><b>OS 63</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_63 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_63();

		/**
		 * The meta object literal for the '<em><b>OS 64</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_64 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_64();

		/**
		 * The meta object literal for the '<em><b>OS 65</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_65 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_65();

		/**
		 * The meta object literal for the '<em><b>OS 70</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_70 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_70();

		/**
		 * The meta object literal for the '<em><b>OS 71</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_71 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_71();

		/**
		 * The meta object literal for the '<em><b>OS 80</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_80 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_80();

		/**
		 * The meta object literal for the '<em><b>OS 81</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_81 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_81();

		/**
		 * The meta object literal for the '<em><b>OS 82</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_82 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_82();

		/**
		 * The meta object literal for the '<em><b>OS 90</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_90 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_90();

		/**
		 * The meta object literal for the '<em><b>OS 100</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_OPERATING_SYSTEM_ENUMERATION__OS_100 = eINSTANCE.getHyadesOperatingSystemEnumeration_OS_100();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesOperatingSystemCategoryImpl <em>Hyades Operating System Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesOperatingSystemCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesOperatingSystemCategory()
		 * @generated
		 */
		EClass HYADES_OPERATING_SYSTEM_CATEGORY = eINSTANCE.getHyadesOperatingSystemCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesProcessorTypeCategoryImpl <em>Hyades Processor Type Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesProcessorTypeCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesProcessorTypeCategory()
		 * @generated
		 */
		EClass HYADES_PROCESSOR_TYPE_CATEGORY = eINSTANCE.getHyadesProcessorTypeCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesMemorySizeCategoryImpl <em>Hyades Memory Size Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesMemorySizeCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesMemorySizeCategory()
		 * @generated
		 */
		EClass HYADES_MEMORY_SIZE_CATEGORY = eINSTANCE.getHyadesMemorySizeCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesProcessorSpeedCategoryImpl <em>Hyades Processor Speed Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesProcessorSpeedCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesProcessorSpeedCategory()
		 * @generated
		 */
		EClass HYADES_PROCESSOR_SPEED_CATEGORY = eINSTANCE.getHyadesProcessorSpeedCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesProcessorTypeEnumerationImpl <em>Hyades Processor Type Enumeration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesProcessorTypeEnumerationImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesProcessorTypeEnumeration()
		 * @generated
		 */
		EClass HYADES_PROCESSOR_TYPE_ENUMERATION = eINSTANCE.getHyadesProcessorTypeEnumeration();

		/**
		 * The meta object literal for the '<em><b>PR 1</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_1 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_1();

		/**
		 * The meta object literal for the '<em><b>PR 2</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_2 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_2();

		/**
		 * The meta object literal for the '<em><b>PR 3</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_3 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_3();

		/**
		 * The meta object literal for the '<em><b>PR 4</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_4 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_4();

		/**
		 * The meta object literal for the '<em><b>PR 5</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_5 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_5();

		/**
		 * The meta object literal for the '<em><b>PR 6</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_6 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_6();

		/**
		 * The meta object literal for the '<em><b>PR 7</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_7 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_7();

		/**
		 * The meta object literal for the '<em><b>PR 8</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_8 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_8();

		/**
		 * The meta object literal for the '<em><b>PR 9</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_9 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_9();

		/**
		 * The meta object literal for the '<em><b>PR 10</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_10 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_10();

		/**
		 * The meta object literal for the '<em><b>PR 11</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_11 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_11();

		/**
		 * The meta object literal for the '<em><b>PR 12</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_12 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_12();

		/**
		 * The meta object literal for the '<em><b>PR 13</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_13 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_13();

		/**
		 * The meta object literal for the '<em><b>PR 14</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_14 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_14();

		/**
		 * The meta object literal for the '<em><b>PR 15</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_15 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_15();

		/**
		 * The meta object literal for the '<em><b>PR 16</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_16 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_16();

		/**
		 * The meta object literal for the '<em><b>PR 17</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_17 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_17();

		/**
		 * The meta object literal for the '<em><b>PR 18</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_18 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_18();

		/**
		 * The meta object literal for the '<em><b>PR 19</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_19 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_19();

		/**
		 * The meta object literal for the '<em><b>PR 50</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_50 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_50();

		/**
		 * The meta object literal for the '<em><b>PR 51</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_51 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_51();

		/**
		 * The meta object literal for the '<em><b>PR 52</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_52 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_52();

		/**
		 * The meta object literal for the '<em><b>PR 53</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_53 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_53();

		/**
		 * The meta object literal for the '<em><b>PR 54</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_54 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_54();

		/**
		 * The meta object literal for the '<em><b>PR 55</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_55 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_55();

		/**
		 * The meta object literal for the '<em><b>PR 56</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_56 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_56();

		/**
		 * The meta object literal for the '<em><b>PR 57</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_57 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_57();

		/**
		 * The meta object literal for the '<em><b>PR 58</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_58 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_58();

		/**
		 * The meta object literal for the '<em><b>PR 59</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_59 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_59();

		/**
		 * The meta object literal for the '<em><b>PR 60</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_PROCESSOR_TYPE_ENUMERATION__PR_60 = eINSTANCE.getHyadesProcessorTypeEnumeration_PR_60();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesBrowserTypeCategoryImpl <em>Hyades Browser Type Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesBrowserTypeCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesBrowserTypeCategory()
		 * @generated
		 */
		EClass HYADES_BROWSER_TYPE_CATEGORY = eINSTANCE.getHyadesBrowserTypeCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesBrowserVersionCategoryImpl <em>Hyades Browser Version Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesBrowserVersionCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesBrowserVersionCategory()
		 * @generated
		 */
		EClass HYADES_BROWSER_VERSION_CATEGORY = eINSTANCE.getHyadesBrowserVersionCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesBrowserEnumerationImpl <em>Hyades Browser Enumeration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesBrowserEnumerationImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesBrowserEnumeration()
		 * @generated
		 */
		EClass HYADES_BROWSER_ENUMERATION = eINSTANCE.getHyadesBrowserEnumeration();

		/**
		 * The meta object literal for the '<em><b>WB 1</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_BROWSER_ENUMERATION__WB_1 = eINSTANCE.getHyadesBrowserEnumeration_WB_1();

		/**
		 * The meta object literal for the '<em><b>WB 2</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_BROWSER_ENUMERATION__WB_2 = eINSTANCE.getHyadesBrowserEnumeration_WB_2();

		/**
		 * The meta object literal for the '<em><b>WB 3</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_BROWSER_ENUMERATION__WB_3 = eINSTANCE.getHyadesBrowserEnumeration_WB_3();

		/**
		 * The meta object literal for the '<em><b>WB 4</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_BROWSER_ENUMERATION__WB_4 = eINSTANCE.getHyadesBrowserEnumeration_WB_4();

		/**
		 * The meta object literal for the '<em><b>WB 5</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_BROWSER_ENUMERATION__WB_5 = eINSTANCE.getHyadesBrowserEnumeration_WB_5();

		/**
		 * The meta object literal for the '<em><b>WB 6</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_BROWSER_ENUMERATION__WB_6 = eINSTANCE.getHyadesBrowserEnumeration_WB_6();

		/**
		 * The meta object literal for the '<em><b>WB 7</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_BROWSER_ENUMERATION__WB_7 = eINSTANCE.getHyadesBrowserEnumeration_WB_7();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesProcessorNumberCategoryImpl <em>Hyades Processor Number Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesProcessorNumberCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesProcessorNumberCategory()
		 * @generated
		 */
		EClass HYADES_PROCESSOR_NUMBER_CATEGORY = eINSTANCE.getHyadesProcessorNumberCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayColorDepthCategoryImpl <em>Hyades Display Color Depth Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayColorDepthCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesDisplayColorDepthCategory()
		 * @generated
		 */
		EClass HYADES_DISPLAY_COLOR_DEPTH_CATEGORY = eINSTANCE.getHyadesDisplayColorDepthCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayColorDepthEnumerationImpl <em>Hyades Display Color Depth Enumeration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayColorDepthEnumerationImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesDisplayColorDepthEnumeration()
		 * @generated
		 */
		EClass HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION = eINSTANCE.getHyadesDisplayColorDepthEnumeration();

		/**
		 * The meta object literal for the '<em><b>DCD 1</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_1 = eINSTANCE.getHyadesDisplayColorDepthEnumeration_DCD_1();

		/**
		 * The meta object literal for the '<em><b>DCD 2</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_2 = eINSTANCE.getHyadesDisplayColorDepthEnumeration_DCD_2();

		/**
		 * The meta object literal for the '<em><b>DCD 3</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_3 = eINSTANCE.getHyadesDisplayColorDepthEnumeration_DCD_3();

		/**
		 * The meta object literal for the '<em><b>DCD 4</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_4 = eINSTANCE.getHyadesDisplayColorDepthEnumeration_DCD_4();

		/**
		 * The meta object literal for the '<em><b>DCD 5</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_5 = eINSTANCE.getHyadesDisplayColorDepthEnumeration_DCD_5();

		/**
		 * The meta object literal for the '<em><b>DCD 6</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_6 = eINSTANCE.getHyadesDisplayColorDepthEnumeration_DCD_6();

		/**
		 * The meta object literal for the '<em><b>DCD 7</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_7 = eINSTANCE.getHyadesDisplayColorDepthEnumeration_DCD_7();

		/**
		 * The meta object literal for the '<em><b>DCD 8</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_8 = eINSTANCE.getHyadesDisplayColorDepthEnumeration_DCD_8();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayHeightCategoryImpl <em>Hyades Display Height Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayHeightCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesDisplayHeightCategory()
		 * @generated
		 */
		EClass HYADES_DISPLAY_HEIGHT_CATEGORY = eINSTANCE.getHyadesDisplayHeightCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayWidthCategoryImpl <em>Hyades Display Width Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayWidthCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesDisplayWidthCategory()
		 * @generated
		 */
		EClass HYADES_DISPLAY_WIDTH_CATEGORY = eINSTANCE.getHyadesDisplayWidthCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayHeightEnumerationImpl <em>Hyades Display Height Enumeration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayHeightEnumerationImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesDisplayHeightEnumeration()
		 * @generated
		 */
		EClass HYADES_DISPLAY_HEIGHT_ENUMERATION = eINSTANCE.getHyadesDisplayHeightEnumeration();

		/**
		 * The meta object literal for the '<em><b>DH 1</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_HEIGHT_ENUMERATION__DH_1 = eINSTANCE.getHyadesDisplayHeightEnumeration_DH_1();

		/**
		 * The meta object literal for the '<em><b>DH 2</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_HEIGHT_ENUMERATION__DH_2 = eINSTANCE.getHyadesDisplayHeightEnumeration_DH_2();

		/**
		 * The meta object literal for the '<em><b>DH 3</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_HEIGHT_ENUMERATION__DH_3 = eINSTANCE.getHyadesDisplayHeightEnumeration_DH_3();

		/**
		 * The meta object literal for the '<em><b>DH 4</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_HEIGHT_ENUMERATION__DH_4 = eINSTANCE.getHyadesDisplayHeightEnumeration_DH_4();

		/**
		 * The meta object literal for the '<em><b>DH 5</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_HEIGHT_ENUMERATION__DH_5 = eINSTANCE.getHyadesDisplayHeightEnumeration_DH_5();

		/**
		 * The meta object literal for the '<em><b>DH 6</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_HEIGHT_ENUMERATION__DH_6 = eINSTANCE.getHyadesDisplayHeightEnumeration_DH_6();

		/**
		 * The meta object literal for the '<em><b>DH 7</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_HEIGHT_ENUMERATION__DH_7 = eINSTANCE.getHyadesDisplayHeightEnumeration_DH_7();

		/**
		 * The meta object literal for the '<em><b>DH 8</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_HEIGHT_ENUMERATION__DH_8 = eINSTANCE.getHyadesDisplayHeightEnumeration_DH_8();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayWidthEnumerationImpl <em>Hyades Display Width Enumeration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayWidthEnumerationImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesDisplayWidthEnumeration()
		 * @generated
		 */
		EClass HYADES_DISPLAY_WIDTH_ENUMERATION = eINSTANCE.getHyadesDisplayWidthEnumeration();

		/**
		 * The meta object literal for the '<em><b>DW 1</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_WIDTH_ENUMERATION__DW_1 = eINSTANCE.getHyadesDisplayWidthEnumeration_DW_1();

		/**
		 * The meta object literal for the '<em><b>DW 2</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_WIDTH_ENUMERATION__DW_2 = eINSTANCE.getHyadesDisplayWidthEnumeration_DW_2();

		/**
		 * The meta object literal for the '<em><b>DW 3</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_WIDTH_ENUMERATION__DW_3 = eINSTANCE.getHyadesDisplayWidthEnumeration_DW_3();

		/**
		 * The meta object literal for the '<em><b>DW 4</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_WIDTH_ENUMERATION__DW_4 = eINSTANCE.getHyadesDisplayWidthEnumeration_DW_4();

		/**
		 * The meta object literal for the '<em><b>DW 5</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_WIDTH_ENUMERATION__DW_5 = eINSTANCE.getHyadesDisplayWidthEnumeration_DW_5();

		/**
		 * The meta object literal for the '<em><b>DW 6</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_WIDTH_ENUMERATION__DW_6 = eINSTANCE.getHyadesDisplayWidthEnumeration_DW_6();

		/**
		 * The meta object literal for the '<em><b>DW 7</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_WIDTH_ENUMERATION__DW_7 = eINSTANCE.getHyadesDisplayWidthEnumeration_DW_7();

		/**
		 * The meta object literal for the '<em><b>DW 8</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DISPLAY_WIDTH_ENUMERATION__DW_8 = eINSTANCE.getHyadesDisplayWidthEnumeration_DW_8();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayNumberCategoryImpl <em>Hyades Display Number Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayNumberCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesDisplayNumberCategory()
		 * @generated
		 */
		EClass HYADES_DISPLAY_NUMBER_CATEGORY = eINSTANCE.getHyadesDisplayNumberCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDatabaseCategoryImpl <em>Hyades Database Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesDatabaseCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesDatabaseCategory()
		 * @generated
		 */
		EClass HYADES_DATABASE_CATEGORY = eINSTANCE.getHyadesDatabaseCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDatabaseVersionCategoryImpl <em>Hyades Database Version Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesDatabaseVersionCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesDatabaseVersionCategory()
		 * @generated
		 */
		EClass HYADES_DATABASE_VERSION_CATEGORY = eINSTANCE.getHyadesDatabaseVersionCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDatabaseEnumerationImpl <em>Hyades Database Enumeration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesDatabaseEnumerationImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesDatabaseEnumeration()
		 * @generated
		 */
		EClass HYADES_DATABASE_ENUMERATION = eINSTANCE.getHyadesDatabaseEnumeration();

		/**
		 * The meta object literal for the '<em><b>DB 1</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DATABASE_ENUMERATION__DB_1 = eINSTANCE.getHyadesDatabaseEnumeration_DB_1();

		/**
		 * The meta object literal for the '<em><b>DB 2</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DATABASE_ENUMERATION__DB_2 = eINSTANCE.getHyadesDatabaseEnumeration_DB_2();

		/**
		 * The meta object literal for the '<em><b>DB 3</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DATABASE_ENUMERATION__DB_3 = eINSTANCE.getHyadesDatabaseEnumeration_DB_3();

		/**
		 * The meta object literal for the '<em><b>DB 4</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_DATABASE_ENUMERATION__DB_4 = eINSTANCE.getHyadesDatabaseEnumeration_DB_4();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGMachineInstanceImpl <em>CFG Machine Instance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.CFGMachineInstanceImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGMachineInstance()
		 * @generated
		 */
		EClass CFG_MACHINE_INSTANCE = eINSTANCE.getCFGMachineInstance();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGMachineConstraintImpl <em>CFG Machine Constraint</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.CFGMachineConstraintImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGMachineConstraint()
		 * @generated
		 */
		EClass CFG_MACHINE_CONSTRAINT = eINSTANCE.getCFGMachineConstraint();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGConfigurableObjectImpl <em>CFG Configurable Object</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.CFGConfigurableObjectImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGConfigurableObject()
		 * @generated
		 */
		EClass CFG_CONFIGURABLE_OBJECT = eINSTANCE.getCFGConfigurableObject();

		/**
		 * The meta object literal for the '<em><b>Property Groups</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_CONFIGURABLE_OBJECT__PROPERTY_GROUPS = eINSTANCE.getCFGConfigurableObject_PropertyGroups();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesHostnameCategoryImpl <em>Hyades Hostname Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesHostnameCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesHostnameCategory()
		 * @generated
		 */
		EClass HYADES_HOSTNAME_CATEGORY = eINSTANCE.getHyadesHostnameCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesWindowsDomainCategoryImpl <em>Hyades Windows Domain Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesWindowsDomainCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesWindowsDomainCategory()
		 * @generated
		 */
		EClass HYADES_WINDOWS_DOMAIN_CATEGORY = eINSTANCE.getHyadesWindowsDomainCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesUsernameCategoryImpl <em>Hyades Username Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesUsernameCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesUsernameCategory()
		 * @generated
		 */
		EClass HYADES_USERNAME_CATEGORY = eINSTANCE.getHyadesUsernameCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesServicePackCategoryImpl <em>Hyades Service Pack Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesServicePackCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesServicePackCategory()
		 * @generated
		 */
		EClass HYADES_SERVICE_PACK_CATEGORY = eINSTANCE.getHyadesServicePackCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesMajorVersionCategoryImpl <em>Hyades Major Version Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesMajorVersionCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesMajorVersionCategory()
		 * @generated
		 */
		EClass HYADES_MAJOR_VERSION_CATEGORY = eINSTANCE.getHyadesMajorVersionCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesMinorVersionCategoryImpl <em>Hyades Minor Version Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesMinorVersionCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesMinorVersionCategory()
		 * @generated
		 */
		EClass HYADES_MINOR_VERSION_CATEGORY = eINSTANCE.getHyadesMinorVersionCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesServicePackEnumerationImpl <em>Hyades Service Pack Enumeration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesServicePackEnumerationImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesServicePackEnumeration()
		 * @generated
		 */
		EClass HYADES_SERVICE_PACK_ENUMERATION = eINSTANCE.getHyadesServicePackEnumeration();

		/**
		 * The meta object literal for the '<em><b>SP 1</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_1 = eINSTANCE.getHyadesServicePackEnumeration_SP_1();

		/**
		 * The meta object literal for the '<em><b>SP 2</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_2 = eINSTANCE.getHyadesServicePackEnumeration_SP_2();

		/**
		 * The meta object literal for the '<em><b>SP 3</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_3 = eINSTANCE.getHyadesServicePackEnumeration_SP_3();

		/**
		 * The meta object literal for the '<em><b>SP 4</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_4 = eINSTANCE.getHyadesServicePackEnumeration_SP_4();

		/**
		 * The meta object literal for the '<em><b>SP 5</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_5 = eINSTANCE.getHyadesServicePackEnumeration_SP_5();

		/**
		 * The meta object literal for the '<em><b>SP 6</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_6 = eINSTANCE.getHyadesServicePackEnumeration_SP_6();

		/**
		 * The meta object literal for the '<em><b>SP 7</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_7 = eINSTANCE.getHyadesServicePackEnumeration_SP_7();

		/**
		 * The meta object literal for the '<em><b>SP 8</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_8 = eINSTANCE.getHyadesServicePackEnumeration_SP_8();

		/**
		 * The meta object literal for the '<em><b>SP 9</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_9 = eINSTANCE.getHyadesServicePackEnumeration_SP_9();

		/**
		 * The meta object literal for the '<em><b>SP 100</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_100 = eINSTANCE.getHyadesServicePackEnumeration_SP_100();

		/**
		 * The meta object literal for the '<em><b>SP 101</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_101 = eINSTANCE.getHyadesServicePackEnumeration_SP_101();

		/**
		 * The meta object literal for the '<em><b>SP 200</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_200 = eINSTANCE.getHyadesServicePackEnumeration_SP_200();

		/**
		 * The meta object literal for the '<em><b>SP 201</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_201 = eINSTANCE.getHyadesServicePackEnumeration_SP_201();

		/**
		 * The meta object literal for the '<em><b>SP 300</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_300 = eINSTANCE.getHyadesServicePackEnumeration_SP_300();

		/**
		 * The meta object literal for the '<em><b>SP 301</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_301 = eINSTANCE.getHyadesServicePackEnumeration_SP_301();

		/**
		 * The meta object literal for the '<em><b>SP 400</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_400 = eINSTANCE.getHyadesServicePackEnumeration_SP_400();

		/**
		 * The meta object literal for the '<em><b>SP 401</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_401 = eINSTANCE.getHyadesServicePackEnumeration_SP_401();

		/**
		 * The meta object literal for the '<em><b>SP 500</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_500 = eINSTANCE.getHyadesServicePackEnumeration_SP_500();

		/**
		 * The meta object literal for the '<em><b>SP 501</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_501 = eINSTANCE.getHyadesServicePackEnumeration_SP_501();

		/**
		 * The meta object literal for the '<em><b>SP 600</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_600 = eINSTANCE.getHyadesServicePackEnumeration_SP_600();

		/**
		 * The meta object literal for the '<em><b>SP 601</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_601 = eINSTANCE.getHyadesServicePackEnumeration_SP_601();

		/**
		 * The meta object literal for the '<em><b>SP 700</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_700 = eINSTANCE.getHyadesServicePackEnumeration_SP_700();

		/**
		 * The meta object literal for the '<em><b>SP 701</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_701 = eINSTANCE.getHyadesServicePackEnumeration_SP_701();

		/**
		 * The meta object literal for the '<em><b>SP 800</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_800 = eINSTANCE.getHyadesServicePackEnumeration_SP_800();

		/**
		 * The meta object literal for the '<em><b>SP 801</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_801 = eINSTANCE.getHyadesServicePackEnumeration_SP_801();

		/**
		 * The meta object literal for the '<em><b>SP 900</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_900 = eINSTANCE.getHyadesServicePackEnumeration_SP_900();

		/**
		 * The meta object literal for the '<em><b>SP 901</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HYADES_SERVICE_PACK_ENUMERATION__SP_901 = eINSTANCE.getHyadesServicePackEnumeration_SP_901();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGArtifactLocationPairImpl <em>CFG Artifact Location Pair</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.CFGArtifactLocationPairImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGArtifactLocationPair()
		 * @generated
		 */
		EClass CFG_ARTIFACT_LOCATION_PAIR = eINSTANCE.getCFGArtifactLocationPair();

		/**
		 * The meta object literal for the '<em><b>Location</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_ARTIFACT_LOCATION_PAIR__LOCATION = eINSTANCE.getCFGArtifactLocationPair_Location();

		/**
		 * The meta object literal for the '<em><b>Artifact</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_ARTIFACT_LOCATION_PAIR__ARTIFACT = eINSTANCE.getCFGArtifactLocationPair_Artifact();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGMachineImpl <em>CFG Machine</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.CFGMachineImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGMachine()
		 * @generated
		 */
		EClass CFG_MACHINE = eINSTANCE.getCFGMachine();

		/**
		 * The meta object literal for the '<em><b>Host Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CFG_MACHINE__HOST_NAME = eINSTANCE.getCFGMachine_HostName();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGPsudoEnumerationImpl <em>CFG Psudo Enumeration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.CFGPsudoEnumerationImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGPsudoEnumeration()
		 * @generated
		 */
		EClass CFG_PSUDO_ENUMERATION = eINSTANCE.getCFGPsudoEnumeration();

		/**
		 * The meta object literal for the '<em><b>Values</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CFG_PSUDO_ENUMERATION__VALUES = eINSTANCE.getCFGPsudoEnumeration_Values();

		/**
		 * The meta object literal for the '<em><b>Category</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CFG_PSUDO_ENUMERATION__CATEGORY = eINSTANCE.getCFGPsudoEnumeration_Category();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesPasswordCategoryImpl <em>Hyades Password Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesPasswordCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesPasswordCategory()
		 * @generated
		 */
		EClass HYADES_PASSWORD_CATEGORY = eINSTANCE.getHyadesPasswordCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesClasspathCategoryImpl <em>Hyades Classpath Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesClasspathCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesClasspathCategory()
		 * @generated
		 */
		EClass HYADES_CLASSPATH_CATEGORY = eINSTANCE.getHyadesClasspathCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.impl.HyadesRootDirectroyCategoryImpl <em>Hyades Root Directroy Category</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.impl.HyadesRootDirectroyCategoryImpl
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getHyadesRootDirectroyCategory()
		 * @generated
		 */
		EClass HYADES_ROOT_DIRECTROY_CATEGORY = eINSTANCE.getHyadesRootDirectroyCategory();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.CFGCategorySelectionMode <em>CFG Category Selection Mode</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.CFGCategorySelectionMode
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGCategorySelectionMode()
		 * @generated
		 */
		EEnum CFG_CATEGORY_SELECTION_MODE = eINSTANCE.getCFGCategorySelectionMode();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.CFGCategorySelectionAmount <em>CFG Category Selection Amount</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.CFGCategorySelectionAmount
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGCategorySelectionAmount()
		 * @generated
		 */
		EEnum CFG_CATEGORY_SELECTION_AMOUNT = eINSTANCE.getCFGCategorySelectionAmount();

		/**
		 * The meta object literal for the '{@link org.eclipse.hyades.models.common.configuration.CFGCategorySelectionMultiplicity <em>CFG Category Selection Multiplicity</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.hyades.models.common.configuration.CFGCategorySelectionMultiplicity
		 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGCategorySelectionMultiplicity()
		 * @generated
		 */
		EEnum CFG_CATEGORY_SELECTION_MULTIPLICITY = eINSTANCE.getCFGCategorySelectionMultiplicity();

	}

} //Common_ConfigurationPackage
